
=head1 NAME

Message - Object representing a message in the Eps subsystem.
          (used only by eNotifyd)

=head1 SYNOPSIS

    use Message;

    ...

=head1 DESCRIPTION

To be defined.

=cut

package Message;

use strict;
use StandardTools;
use HashTools;

=head1 FUNCTIONS/METHODS

=head2 new

B<SYNOPSIS>

B<$myMsg = new Message [$msgFilePath];>

B<ARGUMENTS>

=over 8

=item * $msgFilePath

(Optional) A path to the file containing the unsent message.

=back

B<DESCRIPTION>

To be defined.

B<RETURN VALUE>

The newly created Message object if successful, undef otherwise.

=cut

sub new
{
	die "Usage: Message::new [mdsFilePath]\n" if ( $#_ > 1);

	my $class = shift;
	my $msgFilePath = shift;
	my (%msg);

	my $msgDetail = loadHash( $msgFilePath );

	if (defined($msgDetail)) {
		print ERRLOG "Loaded message: $msgFilePath\n" if ($debug);

		$msg{raw} = $msgDetail;
		$msg{filename} = $msgFilePath;

		return bless \%msg, $class;
	}

	return undef;
}


1;
