#
# XRsrc - Generated via "xs". Perl-side of perl-C linkage to
# access X resource hooks (xrsrchook).
#
package XRsrc;

use strict;
use Carp;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
# @EXPORT = qw();
$VERSION = '0.2';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
		croak "Your vendor has not defined XRsrc macro $constname";
	}
    }
    eval "sub $AUTOLOAD { $val }";
    goto &$AUTOLOAD;
}

bootstrap XRsrc $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

XRsrc - Perl extension for primitive X resource functionality

=head1 SYNOPSIS

  use XRsrc;

  Provides access to low-level routines for managing X resource
  database information. See XResources.pm for higher-level access.

=head1 DESCRIPTION

Perl-side of perl extension to allow perl to access X resource
functions. Provides only minimum functionality necessary to allow
us to create a higher-level XResources object in perl (XResources.pm).

I<No attempt> was made to include all defined X resource library
functions.

=head1 Exported constants

  none


=head1 AUTHOR

Paul Mickelson, Contractor, Compaq's Tandem Division.

=head1 SEE ALSO

XResources.pm, perl(1).

=cut

1;
