/*
 * Copyrighted as an unpublished work.
 * (c) Copyright 1987-1995 Computer Associates International, Inc.
 * All rights reserved.
 *
 * RESTRICTED RIGHTS
 *
 * These programs are supplied under a license.  They may be used,
 * disclosed, and/or copied only as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this restricted rights notice.  Use, copying, and/or disclosure
 * of the programs is strictly prohibited unless otherwise provided
 * in the license agreement.
 */
#ident "@(#)unixsrc:usr/src/common/uts/net/inet/inet.cf/Space.c /main/uw7_uk/4"

int in_loglimit = 1024;

#ifndef ARPT_PRUNE
#define ARPT_PRUNE	5*60	/* aging timer, check every 5 min. */
#endif
int	arpt_prune = ARPT_PRUNE;

#ifndef ARPT_KEEP
#define ARPT_KEEP	20*60	/* kill completed entry in 20 minutes */
#endif
int	arpt_keep = ARPT_KEEP;

#ifndef ARPT_DOWN
#define ARPT_DOWN	20	/* hold down for n seconds when deleted */
#endif
int	arpt_down = ARPT_DOWN;

#ifndef ARP_MAXTRIES
#define ARP_MAXTRIES	5	/* times we'll try to get an arp response */
#endif
int	arp_maxtries = ARP_MAXTRIES;

int in_recvspace = 4096;	/* recv space (TCP) */
int in_sendspace = 8192;	/* send space (TCP) */
int in_fullsize = 1;		/* use full-size segments (TCP) */

				/* XXX - should be #define */
				/* XXX - should be in ip/Space.c */
int ip_ttl = 60;		/* default ttl */
int ip_subnetsarelocal = 1;	/* assist in mtu determination */
int ip_perform_pmtu = 1;	/* perform pmtu discovery ? */

#ifndef IPPORT_USERRESERVED
#define IPPORT_USERRESERVED 5000
#endif
short ipport_userreserved = IPPORT_USERRESERVED;

#include <sys/types.h>

/* XXX should come from include file really.
 */
#define MAX_SYM 256
typedef struct in_config {
	char	*ic_kname;		/* symbol name in kernel */
	char	ic_name[MAX_SYM];	/* symbol name */
	caddr_t	ic_addr;		/* kernel address */
	u_long	ic_current;		/* current/default val */
	u_long	ic_minimum;		/* minimum value */
	u_long	ic_maximum;		/* maximum value */
} in_config_t;

#ifndef INCF_MAX_CONFIG
#define INCF_MAX_CONFIG 128
#endif /* !INCF_MAX_CONFIG */

int incf_maxsize = INCF_MAX_CONFIG;
in_config_t in_config_table[INCF_MAX_CONFIG];

int ipforwarding = 0;
int ipsendredirects = 0;
int ip_forward_broadcasts = 0;
int ipnonlocalsrcroute = 0;
int ip_dirbroadcast = 0;
int ipprintfs = 0;

int icmpprintfs = 0;
int icmp_quenchsz = 0;
int icmp_answermask = 0;
int icmp_reply_broadcasts = 0;

int igmpprintfs = 0;

int tcp_ndebug     = 256;	/* size of TCP debug ring */
int tcp_nlpcbhash  = 32;	/* size of TCP listen pcb hash table */
int tcp_nepcbhash  = 512;	/* size of TCP established pcb hash table */
int tcp_ntwpcbhash = 1024;	/* size of TCP time-wait pcb hash table */
int tcp_nppcbhash  = 512;	/* size of TCP port pcb hash tables */
int udp_npcbhash   = 512;	/* size of UDP pcb hash tables */

int tcp_pcb_cache_size = 32;	/* size of TCP front-hash table */
