#ident	"@(#)unixsrc:usr/src/common/uts/fs/nfs/nfs.cf/Space.c /main/uw7_uk/3"
#ident	"$Header: /src/nsc_uw7/usr/src/common_nsc/uts/fs/nfs/nfs.cf/Space.c,v 1.3 2000/03/06 05:52:05 zabby Exp $"

#ifndef _FSKI
#define _FSKI 1
#endif

#include <config.h>
#include <nfs/nfs_clnt.h>

#define NBBY 8	/* number of bits per byte */

/*
 * nfs client tunables
 *
 * max rnodes, max async lwps, max life of async lwp without work,
 * max client handles, default retries for rpc calls, initial timeout
 * in tenths of a sec for rpc calls, number of pages to read ahead
 * authentications cache
 */
int	nrnode = 		NRNODE;
int	nfs_async_max =		NFS_ASYNC_MAX;
int	nfs_async_timeout =	NFS_ASYNC_TIMEOUT;
int	nfs_mmap_timeout =	NFS_MMAP_TIMEOUT;
int	nfs_maxclients =	NFS_MAXCLIENTS;
int	nfs_retries = 		NFS_RETRIES;
int	nfs_timeo =		NFS_TIMEO;
int	nfs_nra =		NFS_NRA;
int	nfs_num_mounts =	NFS_NUM_MOUNTS;

char				nfs_minmap[NFS_NUM_MOUNTS/NBBY];
struct	chtab			chtable[NFS_MAXCLIENTS];
struct	desauthent		desauthtab[NFS_MAXCLIENTS];
struct	unixauthent		unixauthtab[NFS_MAXCLIENTS];

#ifdef NFSESV

struct	esvauthent		esvauthtab[NFS_MAXCLIENTS];

#endif

/*
 * client side global flags
 *
 * do close to open consistancy checking on all filesystems.
 * If this boolean is false, CTO checking can be selectively
 * turned off by setting actimeo to -1 at mount time.
 */
int	nfs_cto =		1;
/*
 * pageout/fsflush_pageflush async request handling
 */
int	nfs_convsysasync =	0;
int	nfs_asyncautotune =	1;

/*
 * use directory name lookup cache
 */
int     nfs_dnlc =		1;

/*
 * unconditional rather than noac anonymous DAC control
 */
int	nfs_anondac =		0;

/*
 * XNFS rather than backward-compatible behaviour.
 */

int	nfs_xnfs = 0;
int	nfs_xnfs_chroot = 0;

/*
 * Disable signals during fault handling.
 */

int	nfs_max_gp_retry_time = 0;

/*
 * Set uid in create requests.
 */

int	nfs_create_uidset = 0;

/*
 * nfs server tunables
 *
 * max life of nfsd lwp without work, max and min nfsd lwps
 */
int	nfsd_timeout =		NFSD_TIMEOUT;
int	nfsd_max =		NFSD_MAX;
int	nfsd_min =		NFSD_MIN;

/*
 * server side global flags.
 */
#ifdef NSC_CFS
int	nfsreadmap = 		0;
#else
int	nfsreadmap = 		1;
#endif
