/*	Copyright (c) 1993 UNIX System Laboratories, Inc.	*/
/*	(a wholly-owned subsidiary of Novell, Inc.).     	*/
/*	All Rights Reserved.                             	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF UNIX SYSTEM     	*/
/*	LABORATORIES, INC. (A WHOLLY-OWNED SUBSIDIARY OF NOVELL, INC.).	*/
/*	The copyright notice above does not evidence any actual or     	*/
/*	intended publication of such source code.                      	*/

#ident	"@(#)kern:fs/nfs/nfs.cf/Space.c	1.9"
#ident	"$Header: /src/nsc_uw7/usr/src/nsc/uts/fs/nsc_cfs/nsc_cfs.cf/Space.c,v 1.5 1999/11/15 22:29:41 dzafman Exp $"

#include <config.h>
#include <sys/param.h>

/*
 * Threshold for cfs paging activity
 *	- when pageout stops putpaging cfs pages
 * Set to < 0 to ineffectuate.
 *
 * NOTE: not upper bounded by some fraction of maxfreemem, like mem_lotsfree
 */
int cfs_paging_threshold = (_BTOP(LOTSFREEBYTES) / 2);

/*
 * nfs client tunables
 *
 * max rnodes, max async lwps, max life of async lwp without work,
 * max client handles, default retries for rpc calls, initial timeout
 * in tenths of a sec for rpc calls, number of pages to read ahead
 * authentications cache
 */
int	ncnode = 		NCNODE;

/*
 * client side global flags
 *
 * do close to open consistancy checking on all filesystems.
 * If this boolean is false, CTO checking can be selectively
 * turned off by setting actimeo to -1 at mount time.
 */
int	cfs_cto =		1;

/*
 * use directory name lookup cache
 */
int     cfs_dnlc =		1;

/*
 * Memory needed by the backup root node (for failover) for
 * user (swappable) and/or kernel (non-swappable) data.
 */
int	cfs_rootbkup_usermem = CFS_ROOTBKUP_USERMEM;
int	cfs_rootbkup_kernmem = CFS_ROOTBKUP_KERNMEM;

#ifdef NOTUSED
/*
 * server side global flags.
 */
int	cfsreadmap = 		1;
#endif /* NOTUSED */
