#ident "@(#)$Header: /src/nsc_uw7/usr/src/nsc/uts/net/nsc_dnet/glue/nscglue.h,v 1.13 2000/03/11 17:26:39 zabby Exp $"

/*
 * Copyright (c) 2000 Compaq Computer Corporation
 *        All Rights Reserved
 */

#ifndef _NSC_DNET_GLUE_NSCGLUE_H
#define _NSC_DNET_GLUE_NSCGLUE_H

#ifdef _KERNEL_HEADERS
#include <nsc/nsc.h>
#include <util/ksynch.h>
#include <nsc/nsc_synch.h>
#include <io/stream.h>
#ifdef NSC_EXNFS
#include <fs/vfs.h>
#endif /* NSC_EXNFS */
#include <net/nsc_dnet/dnet_in.h>
#else
#include <sys/nsc.h>
#include <sys/stream.h>
#include <net/nerd_tuple.h>
#endif


/*
 * The following structure is used to track both upper read queues
 * and lower write queues.
 */
typedef struct {
	int			gp_lindex;
	queue_t			*gp_qp;
	int			gp_protocol;
} nscglue_pcb_t;

extern nscglue_pcb_t *nscglue_upper[];
extern nscglue_pcb_t *nscglue_lower[];

#define NSCGLUE_UPPER(_proto)	(nscglue_upper[(_proto) - 1])
#define NSCGLUE_LOWER(_proto)	(nscglue_lower[(_proto) - 1])

/*
 * NSC_GLUE queue type values. 
 *
 * This is the value that is used during configuration using slink.
 * The value must be specified as the parameter to the unitsel command
 * in the slink script (/etc/strcf).
 */
#define NSCGLUE_NONE		0x0
#define NSCGLUE_TCP		0x1
#define NSCGLUE_UDP		0x2
#define NSCGLUE_ICMP		0x4
#define NSCGLUE_IGMP		0x8
#define NSCGLUE_RAWIP		0x10

extern clusternode_t nscglue_if_node(nerd_addr_t *);
extern void nscglue_linput(queue_t *, mblk_t *, clusternode_t);
extern void nscglue_uderr(queue_t *, mblk_t *);
extern int nscglue_type2proto(int);
extern int nscglue_sap2proto(unsigned long);
extern unsigned long nscglue_proto2sap(int);
extern int nscglue_pass_up_protocol(int, mblk_t *);
extern void nscglue_pass_up(queue_t *, mblk_t *);
extern void nscglue_pass_up_remote(clusternode_t, queue_t *, mblk_t *);
extern void nscglue_pass_down(queue_t *, mblk_t *);

#endif /* _NSC_DNET_GLUE_NSCGLUE_ */H
