/*
#ident "@(#)$Header: /src/nsc_uw7/usr/src/nsc/uts/fs/nsc_cfs/cfs_clnt.h,v 3.66 2000/03/06 06:03:53 zabby Exp $"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*
 * Copyright (c) 1993 Locus Computing Corporation
 *        All Rights Reserved
 */

#ifndef _NSC_CFE_CFS_CLNT_H
#define _NSC_CFE_CFS_CLNT_H

#ident	"@(#)gencfs:cfs_clnt.h	1.2"

/*	  @(#)nfs_clnt.h 2.28 88/08/19 SMI	*/

/*
 *  		PROPRIETARY NOTICE (Combined)
 *
 *  This source code is unpublished proprietary information
 *  constituting, or derived under license from AT&T's Unix(r) System V.
 *
 *
 *
 *  		Copyright Notice
 *
 *  Notice of copyright on this source code product does not indicate
 *  publication.
 *
 *  	(c) 1986,1987,1988,1989  Sun Microsystems, Inc.
 *  	(c) 1983,1984,1985,1986,1987,1988,1989  AT&T.
 *  	          All rights reserved.
 */

#ifdef _KERNEL

#ifdef NSC_UW7
#include <fs/fski.h>
#endif
#include <fs/statvfs.h>
#include <fs/vnode.h>
#include <fs/nfs/nfs_clnt.h>
#include <nsc/nsc.h>
#include <nsc/nsc_synch.h>
#include <fs/nsc_cfs/cms.h>
#include <fs/nsc_cfs/cfs_bkcache.h>

/*
 * vfs pointer to mount info
 */
#define	vftocmi(vfsp)	((cfs_mntinfo_t *)((vfsp)->vfs_data))

/*
 * vnode pointer to mount info
 */
#define	vtocmi(vp)	((cfs_mntinfo_t *)(((vp)->v_vfsp)->vfs_data))
#define	ctomi(cp)	vtocmi(ctov(cp))
#define hptomi(hp)	((cfs_mntinfo_t *)(((hp)->sct_vfs)->vfs_data))

/* Is this client vnode on the same node as its server? */
#define	CFS_AT_SERVER(_vp)		(CFS_AT_SERVER_VFS((_vp)->v_vfsp))
#define CFS_AT_SERVER_VFS(_vfsp) 	(CFS_AT_SERVER_MIP(vftocmi(_vfsp)))
#define	CFS_AT_SERVER_MIP(_mip)		((_mip)->mi_server == this_node)

#define	CFS_VFS_BUSY_MIP(_mip) \
	(READ_ATOMIC_INT(&(_mip)->mi_cnodect) != 1 \
	 || (_mip)->mi_rootvp->v_count != 2)

/* Is the VFS up? */
#define	CFS_VFS_UP_MIP(_mip)	(((_mip)->mi_flags & MI_VFS_DOWN) == 0)
#define	CFS_VFS_UP_VFS(_vfsp)	(CFS_VFS_UP_MIP(vftocmi(_vfsp)))

/* Is the external FS server up? */
#define	CFS_VFS_XUP_MIP(_mip) \
	(((_mip)->mi_flags & (MI_DOWN)) == 0)
#define	CFS_VFS_XUP_VFS(_vfsp)	(CFS_VFS_UP_MIP(vftocmi(_vfsp)))

/* Is this VFS in the specfic state? */
#define	CFS_VFS_STATE_MIP(_mip, _state) \
	(!CFS_VFS_UP_MIP(_mip) && (_mip)->mi_vfs_state == (_state))

/* Is this VFS mounted cluster hard? */
#define	CFS_VFS_HARD_MIP(_mip) \
	(((_mip)->mi_flags & (MI_CHARD | MI_CHARDDUP)) != 0)

/* Is this VFS mounted EXNFS hard? */
#define	CFS_VFS_XHARD_MIP(_mip) \
	(((_mip)->mi_flags & (MI_HARDMOUNT)) != 0)

/* Is this thread marked "no wait"? */
#define	CFS_NOWAIT() 		((u.u_lwpp->l_cfs_flag & L_CFS_NOWAIT) != 0)

/* Is this thread a remote operation? */
#define	CFS_REMOTE()		((u.u_lwpp->l_cfs_flag & L_CFS_REMOTE) != 0)

/* Does this vnode's vfs require syncing to disk? */
#define	CFS_SYNC(vp)		((vtocmi(vp)->mi_flags & MI_SYNC) != 0)

/* Sync files on close. */
#define	CFS_SYNC_ON_CLOSE(_cp) \
	(ctomi((_cp))->mi_flags & (MI_CHARD | MI_SYNCONCLOSE))

/*
 * flags for PFS's we stack over
 */
#define CVS_PATHCONF	0x0001		/* pathconf on special for server */
#define	CVS_ROOTNODE	0x0002		/* Stack on CLUSTER_ROOT_SERVICE node */
#define CVS_HARDMOUNT	0x0004		/* Cluster hard okay. */

/* Name of the file containing the fsid. */
#define	NSC_FSID_FILENAME	".fsuid"
/* Maximum length of the file. (All I intend to read, anyway.) */
#define	NSC_FSID_MAX_LEN	32

enum {
	CFS_LM_PFS_ALLOC	= 0x01,
	CFS_LM_PFS_LOCKED	= 0x02,
	CFS_LM_PFS_UNMOUNT	= 0x04,
	CFS_LM_VFS_HELD		= 0x08,
	CFS_LM_VFS_ALLOC	= 0x10,
	CFS_LM_VFS_MIALLOC	= 0x20,
	CFS_LM_VFS_LOCKED	= 0x40,
	CFS_LM_VFS_ADDED	= 0x80,
	CFS_LM_VFS_MOUNTED	= 0x100,
	CFS_LM_VFS_RESERVEDFSID	= 0x200
};

typedef enum {
	MI_VFS_STATE_INVALID,
	MI_VFS_STATE_DOWN_WAIT,
	MI_VFS_STATE_DOWN_DETACH,
	MI_VFS_STATE_DOWN,
	MI_VFS_STATE_REBUILD_HAVES,
	MI_VFS_STATE_REBUILD_HAVES_DONE,
	MI_VFS_STATE_REBUILD_WANTS,
	MI_VFS_STATE_REBUILD_WANTS_DONE,
	MI_VFS_STATE_REBUILD_FLUSH,
	MI_VFS_STATE_REBUILD_FLUSH_DONE,
#ifdef NSC_NIOPS
	MI_VFS_STATE_REBUILD_NIRECOVERY,
	MI_VFS_STATE_REBUILD_NIRECOVERY_DONE,
#endif /* NSC_NIOPS */
	MI_VFS_STATE_UP
} mi_vfs_state_t;

#define	CFS_VFS_STATE_ASSERT(_state) \
	((_state) >= MI_VFS_STATE_DOWN_WAIT \
	 && (_state) <= MI_VFS_STATE_UP)

#define	CFS_FSIDCMP(_fsp1, _fsp2) \
	((_fsp1)->val[0] != (_fsp2)->val[0] \
	 || (_fsp1)->val[1] != (_fsp2)->val[1])

#define	CFS_FIDCMP(_fidp1, _fidp2) \
	((_fidp1)->cf_length != (_fidp2)->cf_length \
	 || bcmp((void *)(_fidp1)->cf_data, (void *)(_fidp2)->cf_data, \
		 (_fidp1)->cf_length))

/* A list type for various kinds of processing. */

typedef struct plist {
	struct plist *pl_nextp;
	void *pl_p;
} plist_t;

#ifdef NSC_NIOPS

/*
 * create an niops handle for this operation
 */

#define CFS_INIT_NIHNDL(_HNDLP, _VFSP) \
	_HNDLP->nich_node = this_node; \
	_HNDLP->nich_pid = u.u_procp->p_epid; \
	_HNDLP->nich_lwpid = u.u_lwpp->l_lwpid; \
	_HNDLP->nich_fsid = _VFSP->vfs_fsid; \
	INCR_ATOMIC_INT(&cfs_nisequence); \
	_HNDLP->nich_seq = READ_ATOMIC_INT(&cfs_nisequence);


/*
 * print an operation handle 
 */
#define NIHNDLP_PRINT(HANDLEP) 
#define NIHNDLE_PRINT(HANDLE)

/*
#define NIHNDLP_PRINT(HANDLEP) \
	if(HANDLEP != NULL) print_nihandle(HANDLEP);
#define NIHNDLE_PRINT(HANDLE) \
	if(HANDLEP != NULL) print_nihandle(&HANDLE);
*/

/*
 * Non-idempotent operations result queue entry
 */

typedef struct ni_resq_ent {
	ni_clihndl	rq_hndl;
	INTR_EVENT_T 	rq_wakeup;
	int	rq_flags;		/* ndpend, forced, onq, etc. */
	int	rq_initial_rslt;
	int	rq_final_rslt;
	struct cfs_mntinfo *rq_qsp;	/* q hung here, in this case, an mip */
	nioptype	rq_which;	/* operation */
	l_off_t	rq_offset;		/* offset expected from write */
	int	rq_resid;		/* resid at write completion */
	cfhandle_t rq_fh;		/* stashed file handle */
	struct cfssattr *rq_attrp;	/* stashed setable attrs */
	caddr_t *rq_resp;		/*rres from create, mkdir, setattr */
	struct ni_resq_ent *rq_forw;
	struct ni_resq_ent *rq_back;
}ni_resq_ent_t;

/* rq_flags definitions */

#define	RQ_NDPEND	0x00000001	/* in nodedown, pending nodeup */
#define	RQ_FORCED 	0x00000002	/* vfs being forced down */
#define	RQ_ONQ		0x00000004	/* true when enqueued */

/* "empty" value for rq_initial and rq_final */

#define CFS_NI_NORSLT	-1

/* fake opcode FS service opcode for CFS service op */
#define CRFS_NIWRITE 101	

/* op gets tokens on completion */
#define CFS_IS_TOKS_PB_OP(_WHICH) \
	(_WHICH == CRFS_NISETATTR || _WHICH == CRFS_NICREATE \
		|| _WHICH == CRFS_NIMKDIR || _WHICH == CRFS_NIWRITE \
			|| _WHICH == CRFS_NICRSAREREQ)

/* 
 * size of nettok array(s) returned by
 * setattr, create, mkdir, and write ops
 */
#define CFS_NETTOKSZ	( (sizeof (struct cfs_nettok)) * CFS_NTOKS)

#define	CFS_INIT_NIRESQE(_RQE, _HNDLP, _WHICH, _MIP); \
	bcopy(_HNDLP, &_RQE->rq_hndl, sizeof( ni_clihndl) ); \
	_RQE->rq_initial_rslt = CFS_NI_NORSLT; \
	_RQE->rq_final_rslt = CFS_NI_NORSLT; \
	_RQE->rq_which = _WHICH; \
	_RQE->rq_qsp = _MIP; \
	_RQE->rq_offset = (l_off_t) CFS_NI_NORSLT; \
	_RQE->rq_resp = NULL; \
	_RQE->rq_flags = 0; \
	if (!CFS_IS_TOKS_PB_OP(_WHICH)) \
		INIT_INTR_EVENT(&_RQE->rq_wakeup);

/*
 * Non-idempotent operations info structure
 * Used in cfs_server.c to pass info "under the covers"
 */

typedef struct ni_info {
	ni_clihndl 	*nii_hndlp;	/* non-idempotent op handle */
	int		nii_which;	/* basic operation type */
	int 		nii_type;	/* request or re-request type */
	agent_t		nii_agent;	/* for create, mkdir, setattr */
	svrhold_list_t  *nii_hlp;	/* for create, mkdir, setattr */
} ni_info_t;

#define IS_NI_INFO_NONE() \
		u.u_lwpp->l_niinfop == NULL
	
#define ASSERT_NI_INFO_NONE() \
	ASSERT(IS_NI_INFO_NONE());
	
#define STASH_NI_INFO(INFOP, HANDLEP, OP, TYPE, AGENT, HLP) \
	ASSERT_NI_INFO_NONE() \
	INFOP->nii_hndlp = HANDLEP; \
	INFOP->nii_type = TYPE; \
	INFOP->nii_which = OP; \
	INFOP->nii_agent = AGENT; \
	INFOP->nii_hlp = HLP; \
	u.u_lwpp->l_niinfop = INFOP;

#define GET_NI_COMMON_INFO(INFOP, HANDLEP, TYPE, WHICH, AGENT, HLP) \
	if ((INFOP = (ni_info_t *) u.u_lwpp->l_niinfop) == NULL ) { \
		HANDLEP = NULL; \
		TYPE = CFS_NINONE; \
		WHICH = CFS_NINONE; \
		AGENT = CFS_NINONE; \
		HLP = NULL; \
	} else { \
		HANDLEP = INFOP->nii_hndlp; \
		TYPE = INFOP->nii_type; \
		WHICH = INFOP->nii_which; \
		AGENT = INFOP->nii_agent; \
		HLP = INFOP->nii_hlp; \
		STASH_NI_INFO_NONE(); \
	}
	
#define STASH_NI_INFO_NONE() \
	u.u_lwpp->l_niinfop = NULL;


#endif /* NSC_NIOPS */

/*
 * CFS private data per mounted file system
 */
typedef struct cfs_mntinfo {
	vnode_t		*mi_rootvp;	/* root vnode */
	clusternode_t	 mi_server;	/* server node number */
	vfs_t		*mi_vfs;       	/* Back pointer to VFS. */
	vfs_t		*mi_pfs_vfs;	/* Physical filesystem vfs */
	char		 mi_pfs_fsname[FSTYPSZ]; /* PFS name. */
	u_int		 mi_flags;	/* flags associated with this vfs */
	int		 mi_mount_flags; /* Mount flags for this VFS. */
	ATOMIC_INT_T	 mi_refct;	/* active vnodes for this vfs */
	ATOMIC_INT_T	 mi_cnodect;	/* total vnodes for this vfs */
	char		*mi_mntpt;	/* mount point */
	COND_LOCK_T	 mi_cond_lock;	/* Lock for server state variables. */
	mi_vfs_state_t   mi_vfs_state;	/* State of "DOWN" vfs. */
	int		 mi_vfs_state_fsops; /* Number of recovery ops. */
	ATOMIC_INT_T	 mi_vfs_fsop_threads; /* Number of active ops. */
	ATOMIC_INT_T	 mi_vfs_locks_pending; /* Number of pending locks. */
	plist_t		*mi_vfs_cnode_listp; /* List of cnodes rebuilt. */
	INTR_CONDITION_T mi_vfs_state_cond; /* Used for state change wait. */
	INTR_CONDITION_T mi_vfs_down_cond; /* Used to sleep for a down vfs. */
	nsc_nodelist_t	*mi_rb_nodelistp; /* Pointer to rebuild nodelist. */
	int		 mi_rb_error; 	/* Rebuild error. */
	struct blkrsrv_data	*mi_clidata;	/* Client block reserve data */
	struct blkrsrv_data	*mi_svrdata;	/* Server block reserve data */
	int		mi_rlwps;	/* number of active lwps */
	int		mi_lwpsmax;	/* max active lwps */
	bcinfo_t	*mi_bcinfop;	/* backup cache information */
	int		mi_notifygen;	/* Up/Down notification # */
	/* NSC_XXX: mi_notifygen should be cleared on nodedown. */
#ifdef NSC_NIOPS 
	ni_resq_ent_t 	*mi_niresq_head;
	ni_resq_ent_t 	*mi_niresq_tail; /* not used in this implementation */
	LOCK_T		mi_niresq_lock;
	ATOMIC_INT_T 	mi_nindpend;	/* ops pending at nodedown */
	ATOMIC_INT_T 	mi_nirecovery;	/* count of ops being recovered */
#endif /* NSC_NIOPS */
	ATOMIC_INT_T	 mi_svrcfstoks; /* Number of server structures. */

/*
 *  Elements below here are left over from the NFS structure
 */

#ifdef NOTNEEDED
	u_int		 mi_hard:1;	/* hard or soft mount */
	u_int		 mi_noac:1;	/* don't cache attributes */
	u_int		 mi_nocto:1;	/* no close-to-open consistency */
	struct knetconfig	*mi_knetconfig;		/* bound TLI fd */
	struct netbuf	 mi_addr;	/* server's address */
	struct netbuf	 mi_syncaddr;	/* AUTH_DES time sync addr */
	u_int		 mi_printed:1;	/* not responding message printed */
	u_int		 mi_int:1;	/* interrupts allowed on hard mount */
	u_int		 mi_dynamic:1;	/* dynamic transfer size adjustment */
	u_int		 mi_grpid:1;	/* System V group id inheritance */
	u_int		 mi_rpctimesync:1;	/* RPC time sync */
	long		 mi_tsize;	/* transfer size (bytes) */
					/* really read size */
	long		 mi_stsize;	/* server's max transfer size (bytes) */
					/* really write size */
	long		 mi_bsize;	/* server's disk block size */
	int		 mi_mntno;	/* kludge to set client rdev for stat*/
	int		 mi_timeo;	/* inital timeout in 10th sec */
	int		 mi_retrans;	/* times to retry request */
	char		 mi_hostname[HOSTNAMESZ];	/* server's hostname */
	char		*mi_netname;	/* server's netname */
	int		 mi_netnamelen;	/* length of netname */
	int		 mi_authflavor;	/* authentication type */
	u_int		 mi_acregmin;	/* min secs to hold cached file attr */
	u_int		 mi_acregmax;	/* max secs to hold cached file attr */
	u_int		 mi_acdirmin;	/* min secs to hold cached dir attr */
	u_int		 mi_acdirmax;	/* max secs to hold cached dir attr */
	/*
	 * Extra fields for congestion control, one per NFS call type,
	 * plus one global one.
	 */
	struct rpc_timers mi_timers[NFS_CALLTYPES+1];
	long		mi_curread;	/* current read size */
	lck_t		mi_mplock;	/* protect internal fields */
#endif /* NOTNEEDED */
} cfs_mntinfo_t;

/* AT_* attributes which never change. */
#define AT_STATIC	(AT_RDEV|AT_FSID|AT_NODEID|AT_TYPE|AT_BLKSIZE)

fid_t *cfhtofid(cfhandle_t *fhp);

void
cflush(vfs_t *vfsp, 
       int flags);

#define CFLUSH_DATA		0x01
#define CFLUSH_ATTRS		0x02
#define CFLUSH_SKIP_LOCKED	0x04

void	
cfree(cnode_t *cp);

int
cfs_build_cnode_list(plist_t **pl_procpp,
		     int flags,
		     int (*filter)(void *filter_arg,
				   int flags,
				   cnode_t *cp, 
				   plist_t **pl_procpp,
				   int *missedp),
		     void *filter_arg);

#define	CFS_BUILD_LOCK_HELD	0x1	/* ctable_lock held on entry. */
#define	CFS_BUILD_SKIP_MISSED	0x2	/* Missed entries okay. */
#define	CFS_BUILD_FREE_ON_RETRY	0x4	/* Free all entries on retry. */
#define	CFS_BUILD_COUNT_FIRST	0x8	/* Count entries first. */

vfs_t *
cfs_build_vfs(cms_mntinfo_t *infop);

void 
cfs_cache_check(svrcfstok_t *hp);

int
cfs_do_build_vfs(vfs_t *vfsp,
		 cms_mntinfo_t *infop);

int
cfs_domount(vfs_t **ppvfsp, 
	    vnode_t *vp, 
	    struct mounta *uap,
	    vfs_t *cfs_vfsp,
	    cms_mntinfo_t *infop);

int
cfs_dostatvfs(vfs_t *vfsp, 
	      statvfs_t *sbp);

int
cfs_dounmount(vfs_t *vfsp,
	      cred_t *crp,
	      int hold_root,
	      int vfs_add,
	      int vfs_locked,
	      int root_vfs);

void
cfs_free_cnode_list(plist_t **pl_procpp);

int	
(*cfs_get_fsid(int fstype, 
	       boolean_t *chard_okp))(vfs_t *pvfsp,
				      const char *mnt_ptp,
				      const char *mnt_specp,
				      int mnt_flags,
				      vfs_t *vfsp,
				      struct cms_mntinfo_t *infop,
				      int *lm_flagsp);

vfs_t *
cfs_getvfs(fsid_t *fsp);

void
cfs_hide_cnodes(vfs_t *vfsp);

void
get_lu_toks(
	struct svrcfstok *hp,
	svrhold_list_t *hold_listp,
	int hints,
	agent_t agent);

#ifdef NSC_NIOPS 
void
get_nilu_toks(
	struct svrcfstok *hp,
	svrhold_list_t *hold_listp,
	int hints,
	agent_t agent);
#endif

#ifdef NSC_UW7
void
cfs_layer_io(void);
#endif /* NSC_UW7 */

int
cfs_layered_mount_1(vnode_t *mvp,
		    vfs_t *vfsp,
		    vfs_t *pvfsp,
		    const char *mnt_pt,
		    const char *mnt_spec,
		    int mnt_flags,
		    cms_mntinfo_t *infop,
		    int *lm_flagsp);

int
cfs_layered_mount_2(vnode_t *mvp,
		    vfs_t *vfsp,
		    vfs_t *pvfsp,
		    const char *mnt_spec,
		    cms_mntinfo_t *infop,
		    int *lm_flagsp,
		    bc_nodelist_t *bclist,
		    int cms_flags);

void
cfs_layered_mount_cleanup(vnode_t *mvp,
			  vfs_t *vfsp,
			  vfs_t *pvfsp,
			  const char *mnt_pt,
			  int *lm_flagsp);

int
cfs_mountroot(vfs_t *vfsp,
	      whymountroot_t why);

void
cfs_mountroot_pfs_remount_done(int error);

int
cfs_nothidden_cnode_filter(void *filter_arg,
			   int flags,
			   cnode_t *cp,
			   plist_t **pl_procpp,
			   int *missedp);

#ifdef NSC_EXNFS
void
cfs_purge_caches(vnode_t *pvp,
		 int type,
		 int vntype,
		 u_long *sizep);
#else
void
cfs_purge_caches(vnode_t *pvp);
#endif

void
cfs_purge_mycache(struct cnode *cp,
		  u_long newgen,
		  u_long newdgen,
		  int type,
		  int vntype);

void
cfs_purge_urcache(cfhandle_t *fhp,
		  u_long newgen,
		  u_long newdgen,
		  int type,
		  int vntype,
		  clusternode_t server);

int
cfs_purge_fs(int fstype);

void
cfs_rb_do_complete(cfsrbphasedoneargs *argsp);

void
cfs_rb_phase_done(vfs_t *vfsp,
		  clusternode_t node,
		  int error,
		  int state,
		  int locked);

void
cfs_rebuild_attach_cnodes(vfs_t *vfsp);

void
cfs_rebuild_tokens(vfs_t *vfsp, 
		   int do_haves);

int
cfs_rebuild_tokens_done(vfs_t *vfsp, 
			clusternode_t server,
			mi_vfs_state_t state);

void
cfs_rm_expmi(cfs_mntinfo_t *cmi);

int
cfs_send_mounton(clusternode_t node,
		 cfhandle_t *fhp, 
		 bool_t covered);

int
cfs_send_rb(clusternode_t node,
	    fsid_t *fsp,
	    clusternode_t bcsvr);

int
cfs_send_rb_complete(clusternode_t node,
		     fsid_t *fsp,
		     clusternode_t cli_node,
		     int op_error,
		     int state,
		     ulong seq);

int
cfs_send_rb_phase_done(clusternode_t node,
		       fsid_t *fsp,
		       clusternode_t cli_node,
		       int op_error,
		       int state);

int
cfs_send_rb_phase_flush(clusternode_t node,
			fsid_t *fsp);

int
cfs_send_rb_phase_haves(clusternode_t node,
			fsid_t *fsp,
			dev_t dev,
			u_long vfs_flags);

int
cfs_send_rb_phase_up(clusternode_t node,
		     fsid_t *fsp);

int
cfs_send_rb_phase_have_done(clusternode_t node,
			    fsid_t *fsp);

int
cfs_send_rb_phase_wants(clusternode_t node,
			fsid_t *fsp);

int
cfs_send_rb_up(clusternode_t node,
	       fsid_t *fsp);

int
cfs_send_set_vfs_flags(clusternode_t node,
		       fsid_t *fsp,
		       u_long vfs_flags);

int
cfs_send_unmount(clusternode_t node,
		 cms_unmount_args *argsp);

#ifdef NSC_IPC

int
cfs_shm_file(char *fname,
	     size_t size,
	     cred_t *credp,
	     vnode_t **vpp);

int
cfs_shm_vfs(char *mnt_pt);

#endif	/* NSC_IPC */

void
cfs_specfs_cleanup(vfs_t *vfsp);

boolean_t
cfs_stackable(int fstype);

int
cfs_nsc_rcall_errno(const char *caller, 
		    enum clnt_stat cli_stat);

void
cfs_tryclean(vfs_t *vfsp);

void
cfs_uncache_all(vfs_t *vfsp);

void
cfs_vfs_add(vnode_t *mvp,
	    vfs_t *vfsp,
	    int vfslist_locked);

int
cfs_vfs_alloc(vfs_t **vfspp,
	      vfssw_t *vswp,
	      void *privatep,
	      int sleep_flag);

int
cfs_vfs_check(cfs_mntinfo_t *mip);

void
cfs_vfs_check_done(cfs_mntinfo_t *mip);

int
cfs_vfs_check_retry(cfs_mntinfo_t *mip,
		    int *errorp);

int
cfs_vfs_convert_mount_flags(int mount_flags);

void
cfs_vfs_detach_pfs(vfs_t *vfsp,
		   int unmount);

vfs_t *
cfs_vfs_devsearch(dev_t dev);

int
cfs_vfs_do_flush(vfs_t *vfsp,
		 mi_vfs_state_t *statep);

int
cfs_vfs_do_haves_done(vfs_t *vfsp,
		      mi_vfs_state_t *statep);

int
cfs_vfs_do_up(vfs_t *vfsp,
	      mi_vfs_state_t *statep);

void
cfs_vfs_free(vfs_t *vfsp);

int
cfs_vfs_get_fsid_from_dev(vfs_t *pvfsp,
			  const char *mnt_ptp,
			  const char *mnt_specp,
			  int mnt_flags,
			  vfs_t *vfsp,
			  struct cms_mntinfo_t *infop,
			  int *lm_flagsp);

int
cfs_vfs_get_fsid_from_file(vfs_t *pvfsp,
			   const char *mnt_ptp,
			   const char *mnt_specp,
			   int mnt_flags,
			   vfs_t *vfsp,
			   struct cms_mntinfo_t *infop,
			   int *lm_flagsp);

int
cfs_vfs_get_fsid_nfs(vfs_t *pvfsp,
		     const char *mnt_ptp,
		     const char *mnt_specp,
		     int mnt_flags,
		     vfs_t *vfsp,
		     struct cms_mntinfo_t *infop,
		     int *lm_flagsp);

int
cfs_vfs_hash(const fsid_t *fsp);

int
cfs_vfs_is_bfs(const vfs_t *vfsp);

int
cfs_vfs_is_cfs(const vfs_t *vfsp);

int
cfs_vfs_is_nfs(const vfs_t *vfsp);

int
cfs_vfs_is_cdfs(const vfs_t *vfsp);

void
cfs_vfs_nirecover_done(cfs_mntinfo_t *mip);

int
cfs_vfs_mi_alloc(vfs_t *vfsp,
		 const char *fsnamep,
		 int mount_flags,
		 const char *mntptp,
		 int mntpt_user,
		 int sleep_flag);

void
cfs_vfs_mi_free(vfs_t *vfsp);

int
cfs_vfs_put_fsid_to_file(vfs_t *vfsp);

void
cfs_vfs_reencode_devs(vfs_t *vfsp);

void
cfs_vfs_remove(vfs_t *vfsp,
	       int vfslist_locked,
	       int mntlocked);

void
cfs_vfs_start_down(vfs_t *vfsp,
		   cfs_umount_t mode,
		   int flag_held);

int
cfs_vfs_start_haves(vfs_t *vfsp, 
		    clusternode_t server,
		    dev_t dev,
		    u_long vfs_flags,
		    mi_vfs_state_t *statep);

int
cfs_vfs_start_nirecover(vfs_t *vfsp,
			mi_vfs_state_t *statep);

int
cfs_vfs_start_wants(vfs_t *vfsp,
		    mi_vfs_state_t *statep);

int
cfs_vfs_tok_waitcount(vfs_t *vfsp);

int
cfs_vfs_wait_down(vfs_t *vfsp,
		  int count_tokwaits);

int
cfs_vnode_is_cfs(const vnode_t *vp);

void
cfs_xnfs_fix_mount_flags(vfs_t *pvfsp, 
			 int *mnt_flagsp);

void
cfsdi_vfsdown(vfs_t *vfsp);

void	
cinactive(cnode_t *cp);

void	
cinval(vfs_t *vfsp, 
       int clean_only);

int
cinval_server(clusternode_t server);

vnode_t *
clifhtovp(cfhandle_t *cfhp);

void
cnattr_to_vattr(vnode_t *vp,
		cfsfattr *cna,
		vattr_t *vap);

int	
cp_rmhash(cnode_t *cp);

void
creactivate(cnode_t *cp);

void
crfs_mounton_0(cfsmountonargs *argsp,
	       int *errorp);

void
crfs_rb_0(cfssendrbargs *argsp,
	  int *errorp);

void
crfs_rb_complete_0(cfsrbphasedoneargs *argsp);

void
crfs_rb_phase_done_0(cfsrbphasedoneargs *argsp);

void
crfs_rb_phase_flush_0(cfsrbargs *argsp);

void
crfs_rb_phase_haves_0(cfsrbargs *argsp);

void
crfs_rb_phase_up_0(cfsrbargs *argsp);

void
crfs_rb_phase_wants_0(cfsrbargs *argsp);

void
crfs_rb_up_0(cfsrbargs *argsp,
	     int *errorp);

void
crfs_set_vfs_flags_0(cms_set_vfs_flags_args *argsp,
		     int *errorp);

void
crfs_unmount_0(cms_unmount_args *argsp, 
	       int *errorp);

void
csattr_to_vattr(cfssattr *csa, 
		vattr_t *vap);

void
fidtocfh(fsid_t *fsp,
	 fid_t *fidp,
	 cfhandle_t *cfhp,
	 int export);

vnode_t *
makecfsnode(cfhandle_t *fhp, 
	    cfsdiropres *resp, 
	    vfs_t *vfsp);

void
print_cfs_mntinfo(cfs_mntinfo_t *mip);
  
svrcfstok_t *
svrtok_lookup(cfhandle_t *fhp, vnode_t *pvp);

int
svrtok_make(cfhandle_t *fhp,
	    vfs_t *(*getvfs)(fsid_t *fsp),
	    struct svrcfstok **hpp);

#ifdef NSC_NIOPS

/*
 * New functions for non-idempotent operations
 */

ni_resq_ent_t *
lookup_resqent( ni_clihndl *handlep );

void
lock_resq( ni_resq_ent_t *entryp );

void
unlock_resq( ni_resq_ent_t *entryp );

void
enqueue_resqent( ni_resq_ent_t *entryp );

void
dequeue_resqent( ni_resq_ent_t *entryp );

int
cfs_rb_phase_nirecover(vfs_t *vfsp, clusternode_t node); 

void
cfs_mkdir_worked(
	struct svrcfstok *dhp,
	struct svrcfstok *newdhp,
	struct cfscreatargs *args,
	struct cfsdiropres *cdr,
	struct vattr *vap);

void
cfs_mkdir_always(
	struct svrcfstok *dhp,
	struct cfscreatargs *args,
	struct cfsdiropres *cdr,
	int error);

void
cfs_create_worked(
	struct svrcfstok *hp,
	tokflgs	tokflags,
	u_long agent,
	credp_t cred,
	struct  cfsdiropres *cdr,
	struct vattr *vap);

void
cfs_create_always(
	struct svrcfstok *dhp,
	struct cfsdiropres *cdr,
	int error,
	svrhold_list_t *dirholdp);

void
cfs_setattr_worked(
	struct svrcfstok *hp,
	struct cfssaargs *args,
	struct cfsattrstat *cns,
	struct vattr *vap);

void
cfs_setattr_always(
	struct svrcfstok *hp,
	struct cfssaargs *args,
	struct cfsattrstat *cns,
	int error);

void
cfs_write_always( 
	struct svrcfstok *hp,
	svrhold_list_t *dirholdp,
	struct cfswriteargs *cwa,
	struct cfswriteres *cwrp,
	int error);

/*
 * protocol service functions
 */

void
crfs_niinitial_0(cfsniiargs *args, int *error);

void
crfs_nicomplete_0(cfsnicompargs *args, int *error);

void
cfs_noni_client_vfsdown(cfs_mntinfo_t *mip);

void
cfs_noni_client_vfsforce(cfs_mntinfo_t *mip);

int
cfs_noni_client_recover(cfs_mntinfo_t *mip);

void
cfs_noni_client_restart(cfs_mntinfo_t *mip);

int
cfs_send_rb_phase_nirecover(clusternode_t node, fsid_t *fsp);

int
rcfs_nicall(
	cfs_mntinfo_t 	*mip,
	int		which,		/* normal RPC operation */
	cfsnihdr 	*nihdrp,	/* header in ni version of args */
	xdrproc_t	xdrargs,	/* xdr func for ni version of args */
	caddr_t		argsp,		/* ptr to normal args w/in ni args */
	xdrproc_t	xdrres,		/* xdr func for return info */
	caddr_t		retp,		/* ptr to return info */
	uio_t		*uiop);		/* uio (only for writes) */

/*
 * server operation functions
 */

int
cfs_comm_nisetattr(
	struct svrcfstok *hp,
	struct vattr *vap,
	int flags,
	int ioflags,
	struct cred *cred);

int
cfs_comm_niwrite(
	struct svrcfstok *hp,
	struct uio *uiop,
	u_long flags,
	struct cred *cred,
	int	do_purge);

int
cfs_comm_nicreate(
	struct svrcfstok *dhp,
	char *nm,
	struct vattr *vap,
	int excl,
	int mode,
	struct svrcfstok **hpp,
	struct cred *cred);

int
cfs_comm_niremove(
	struct svrcfstok *dhp,
	char *nm,
	struct cred *cred);

int
cfs_comm_nirename(
	struct svrcfstok *fromhp,
	char *fnm,
	struct svrcfstok *tohp,
	char *tnm,
	struct cred *cred);

int
cfs_comm_nilink(
	struct svrcfstok *tohp,
	struct svrcfstok *fromhp,
	char *tnm,
	struct cred *cred);

int
cfs_comm_nisymlink(
	struct svrcfstok *hp,
	char *fromnm,
	struct vattr *vap,
	char *tnm,
	struct cred *cred);

int
cfs_comm_nimkdir(
	struct svrcfstok *dhp,
	char *name,
	struct vattr *vap,
	struct svrcfstok **hpp,
	struct cred *cred);

int
cfs_comm_nirmdir(
	struct svrcfstok *hp,
	char *name,
	struct svrcfstok *cdir_hp,
	struct cred *cred);

int
cfs_comm_nisetacl(
	struct svrcfstok *hp,
	long entries, 
	long dentries,
	struct acl *aclbufp,
	struct cred *cr);

int
cfs_comm_nilookup(
	struct svrcfstok *dhp,
	char *nm,
	struct svrcfstok **hpp,
	struct cred *cred);
		
#ifdef DEBUG_TOOLS
void
print_niq( cfs_mntinfo_t *mip );

#endif /* DEBUG_TOOLS */

#ifdef DEBUG

void
print_nihandle( ni_clihndl * handlep);

#endif /* DEBUG */

#endif /* NSC_NIOPS */

int
cfs_unlinkname(struct vnode *vp, char **name);

void
hextostr(char num, char *string);

#ifdef NSC_EXNFS
void 
vattr_to_cnattr(vattr_t *vap, 
		cfsfattr *cna,
		u_long gen, 
		u_long dgen, 
		u_long timeleft);
#else
void 
vattr_to_cnattr(vattr_t *vap, 
		cfsfattr *cna);
#endif /* NSC_EXNFS */


void
vattr_to_csattr(vattr_t *vap,
		cfssattr *csa);

#define	CFS_VFS_FSOP_START(_mip)					\
do {									\
	/* Increment op depth for thread; is this the first call? */	\
	if (u.u_lwpp->l_cfs_fsop_depth++ == 0)				\
		/* Yes: increment active thread count. */		\
		INCR_ATOMIC_INT(&(_mip)->mi_vfs_fsop_threads);		\
	else {								\
		ASSERT(u.u_lwpp->l_cfs_fsop_depth != 0);		\
	}								\
}									\
while (0)

#define	CFS_VFS_FSOP_DONE(_mip)						    \
do {									    \
	 /* Decrement op depth for thread; is this the first call? */	    \
	ASSERT(u.u_lwpp->l_cfs_fsop_depth != 0);			    \
	if (--(u.u_lwpp->l_cfs_fsop_depth) == 0) {			    \
		/* Yes: decrement active thread count. */		    \
		ASSERT(READ_ATOMIC_INT(&(_mip)->mi_vfs_fsop_threads) != 0); \
		DECR_ATOMIC_INT(&(_mip)->mi_vfs_fsop_threads);		    \
		/* Is something happening to this VFS? */		    \
		if ((_mip)->mi_flags & MI_VFS_DOWN)			    \
			/* Yes: do I/O completion check. */		    \
			cfs_vfs_check_done((_mip));			    \
	}								    \
}									    \
while(0)

#define	CFS_VFS_CHECK(_mip)					\
	(((_mip)->mi_flags & (MI_VFS_DOWN | MI_DOWN))		\
	 ? cfs_vfs_check((_mip)) : 0)

#define	CFS_VFS_CHECK_READ_UNLOCK(_error, _mip, _vp, _offset, _len, _fmode) \
do {									    \
	int _tmperr;							    \
	if ((_mip)->mi_flags & (MI_VFS_DOWN | MI_DOWN)) {		    \
		VOP_RWUNLOCK((_vp), (_offset), (_len));			    \
		(_error) = cfs_vfs_check((_mip));			    \
		_tmperr = VOP_RWRDLOCK((_vp), (_offset), (_len), (_fmode)); \
		if (!(_error))						    \
			(_error) = _tmperr;				    \
	}								    \
	else								    \
		(_error) = 0;						    \
} while (0)

#define	CFS_VFS_CHECK_WRITE_UNLOCK(_error, _mip, _vp, _offset, _len, _fmode) \
do {									     \
	int _tmperr;							     \
	if ((_mip)->mi_flags & (MI_VFS_DOWN | MI_DOWN)) {		     \
		VOP_RWUNLOCK((_vp), (_offset), (_len));			     \
		(_error) = cfs_vfs_check((_mip));			     \
		_tmperr = VOP_RWWRLOCK((_vp), (_offset), (_len), (_fmode));  \
		if (!(_error))						     \
			(_error) = _tmperr;				     \
	}								     \
	else								     \
		(_error) = 0;						     \
} while (0)

/* Decide whether to retry; filter error if necessary. */
#define	CFS_VFS_RETRY(_mip, _error)				\
	( (_error) && cfs_vfs_check_retry((_mip), &(_error)) )

/* Error indicates that a retry is required. */
#define CFS_VFS_RETRY_ERROR(_error)				\
	((_error) == ECFS_TRYAGAIN || (_error) == ENFS_TRYAGAIN \
	 || (_error) == ETIMEDOUT || (_error) == EREMOTE \
	 || (_error) == ECFS_NOFSHIP)

/* VFS is mounted cluster soft and it is down. */
#define	CFS_VFS_SOFT_MOUNT_DOWN(_mip)					\
	(((_mip)->mi_flags 						\
	  & (MI_VFS_DOWN | MI_CHARD | MI_CHARDDUP))			\
	  == MI_VFS_DOWN)

/* External defintions. */

extern const char cfs_root_mntpt[];
extern vfsops_t cfs_vfsops;
extern vnodeops_t cfs_vnodeops;
extern clusternode_t root_fs_node;
extern cfs_root_error;
extern vfs_t *cfs_vfs_hash_table[];
#ifdef NSC_UW7
extern const char cfs_io_mntpt[];
extern fsid_t cfs_io_fsid;
extern vnode_t *cfs_io_mvp;
#endif /* NSC_UW7 */

#ifdef NSC_IPC
extern vfs_t *cfs_shm_vfsp;
#endif

#ifdef NSC_EXNFS
/* The following prototypes are for cfs_hm.c */
void cfs_send_exsvrdn(clusternode_t, cfsnotify *);
void cfs_send_exsvrup(clusternode_t, cfsnotify *);
void cfs_exsvradddn(cfs_mntinfo_t *, struct vnode *);

void	cfs_notify_nodes(struct svrcfstok *, void (*func)(), cfsnotify *);
int 	cfs_vfs_do_xup(vfs_t *, int, cfsnotify *, int);

#endif /* NSC_EXNFS */

#ifdef NSC_NIOPS

/*
 * NIOPS macros for cfs_comm_<op>
 * If hardmount, 
 * 	call the cfs_comm_ni<op> version instead
 * else
 * 	normal version
 *
 * NOTE: cfs_comm_lookup included here because hardmount
 * lookups have to be done under lock
 */

#define CFS_COMM_SETATTR(_HP, _VAP, _FLAGS, _IOFLAGS, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_HP))) ? \
		cfs_comm_nisetattr(_HP, _VAP, _FLAGS, _IOFLAGS, _CRED) \
		: cfs_comm_setattr(_HP, _VAP, _FLAGS, _IOFLAGS, _CRED)) 

#define CFS_COMM_CREATE(_DHP, _NM, _VAP, _EXCL, _MODE, _HPP, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_DHP))) ? \
		cfs_comm_nicreate(_DHP, _NM, _VAP, _EXCL, _MODE, _HPP, _CRED) \
		: cfs_comm_create(_DHP, _NM, _VAP, _EXCL, _MODE, _HPP, _CRED))

#define CFS_COMM_REMOVE(_DHP, _NM, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_DHP))) ? \
		cfs_comm_niremove(_DHP, _NM, _CRED) \
		: cfs_comm_remove(_DHP, _NM, _CRED))

#define CFS_COMM_RENAME(_FROMHP, _FNM, _TOHP, _TNM, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_FROMHP))) ? \
		cfs_comm_nirename(_FROMHP, _FNM, _TOHP, _TNM, _CRED) \
		: cfs_comm_rename(_FROMHP, _FNM, _TOHP, _TNM, _CRED))

#define CFS_COMM_LINK(_TOHP, _FROMHP, _TNM, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_FROMHP))) ? \
		cfs_comm_nilink(_TOHP, _FROMHP, _TNM, _CRED) \
		: cfs_comm_link(_TOHP, _FROMHP, _TNM, _CRED))

#define CFS_COMM_SYMLINK(_HP, _FROMNM, _VAP, _TNM, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_HP))) ? \
		cfs_comm_nisymlink(_HP, _FROMNM, _VAP, _TNM, _CRED) \
		: cfs_comm_symlink(_HP, _FROMNM, _VAP, _TNM, _CRED))

#define CFS_COMM_MKDIR(_DHP, _NAME, _VAP, _HPP, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_DHP))) ? \
		cfs_comm_nimkdir(_DHP, _NAME, _VAP, _HPP, _CRED) \
		: cfs_comm_mkdir(_DHP, _NAME, _VAP, _HPP, _CRED))

#define CFS_COMM_RMDIR(_HP, _NAME, _CDIR_HP, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_HP))) ? \
		cfs_comm_nirmdir(_HP, _NAME, _CDIR_HP, _CRED) \
		: cfs_comm_rmdir(_HP, _NAME, _CDIR_HP, _CRED))

#define CFS_COMM_SETACL(_HP, _ENTRIES, _DENTRIES, _ACLBUFP, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_HP))) ? \
		cfs_comm_nisetacl(_HP, _ENTRIES, _DENTRIES, _ACLBUFP, _CRED) \
		: cfs_comm_setacl(_HP, _ENTRIES, _DENTRIES, _ACLBUFP, _CRED))

#define CFS_COMM_LOOKUP(_DHP, _NM, _HPP, _CRED) \
	((CFS_VFS_HARD_MIP(hptomi(_DHP))) ? \
		cfs_comm_nilookup(_DHP, _NM, _HPP, _CRED) \
		: cfs_comm_lookup(_DHP, _NM, _HPP, _CRED))


/*
 * Non-idempotent operations failover protocol support
 */


/*
 * Request (and DEBUG pending) queue management macros
 *
 * Note: These macros may differ on different implementations
 *
 * In this implementation, the queue and its lock are hung off of the vfs,
 * a pointer to which is part of the handle
 * It is a doubly linked list.  We don't use the tail pointer
 * since we don't expect there to be very many outstanding
 * non-idempotent operations outstanding on a single vfs
 * at any one time.  If there are, something else is probably wrong
 * and the performance of enqueue operations probably won't matter.
 */


/*
 * Implementation-specific macros for manipulating the request queue
 * In this case we hang the queue(s) off of the vfs and use
 * sequential lookup on the assumption that there will rarely, if
 * ever, be a long list of pending non-idempotent operations
 * (and if there is, it's an indication of a very slow server
 * so performance at the client side won't matter much)
 */

/* values for which queue to address */
 
#define RESQ_LOOKUP(HANDLEP) \
	lookup_resqent(HANDLEP)

#define RESQ_LOCK(ENTRYP) \
	lock_resq(ENTRYP);

#define RESQ_UNLOCK(ENTRYP) \
	unlock_resq(ENTRYP);

#define RESQ_ENQUEUE(ENTRYP) \
	enqueue_resqent(ENTRYP);

#define RESQ_DEQUEUE(ENTRYP) \
	dequeue_resqent(ENTRYP);

#else /* NOT NSC_NIOPS */

#define CFS_COMM_SETATTR(_HP, _VAP, _FLAGS, _IOFLAGS, _CRED) \
		cfs_comm_setattr(_HP, _VAP, _FLAGS, _IOFLAGS, _CRED); 

#define CFS_COMM_CREATE(_DHP, _NM, _VAP, _EXCL, _MODE, _HPP, _CRED) \
		cfs_comm_create(_DHP, _NM, _VAP, _EXCL, _MODE, _HPP, _CRED);

#define CFS_COMM_REMOVE(_DHP, _NM, _CRED) \
		cfs_comm_remove(_DHP, _NM, _CRED);

#define CFS_COMM_RENAME(_FROMHP, _FNM, _TOHP, _TNM, _CRED) \
		cfs_comm_rename(_FROMHP, _FNM, _TOHP, _TNM, _CRED);

#define CFS_COMM_LINK(_TOHP, _FROMHP, _TNM, _CRED) \
		cfs_comm_link(_TOHP, _FROMHP, _TNM, _CRED);

#define CFS_COMM_SYMLINK(_HP, _FROMNM, _VAP, _TNM, _CRED) \
		cfs_comm_symlink(_HP, _FROMNM, _VAP, _TNM, _CRED);

#define CFS_COMM_MKDIR(_DHP, _NAME, _VAP, _HPP, _CRED) \
		cfs_comm_mkdir(_DHP, _NAME, _VAP, _HPP, _CRED);

#define CFS_COMM_RMDIR(_HP, _NAME, _CDIR_HP, _CRED) \
		cfs_comm_rmdir(_HP, _NAME, _CDIR_HP, _CRED);

#define CFS_COMM_SETACL(_HP, _ENTRIES, _DENTRIES, _ACLBUFP, _CRED) \
		cfs_comm_setacl(_HP, _ENTRIES, _DENTRIES, _ACLBUFP, _CRED);

#define CFS_COMM_LOOKUP(_DHP, _NM, _HPP, _CRED) \
		cfs_comm_lookup(_DHP, _NM, _HPP, _CRED); 


#endif /* NSC_NIOPS */

#endif /* _KERNEL */

/* Definitions needed in user mode. */

/*
 *  mntinfo flags
 */

#define MI_VFS_DOWN	0x01		/* CFS VFS is down. */
#define MI_DYNAMIC	0x02		/* This is a dynamic vfs */
#define MI_TOPFS	0x04		/* file system caches time out */
#define MI_CTOPFS	0x08		/* close-to-open semantics */
#define	MI_RDONLY	0x10		/* Read only. */
#define MI_START_DOWN	0x20		/* VFS is in cfs_vfs_start_down(). */
#define MI_GOING_DOWN	0x40		/* VFS is in process of going down */
#define MI_HARDMOUNT	0x100		/* FS hardmount semantics. */

#define MI_NOATTRCACHE 	0x200		/* don't cache attributes */
#define MI_LOCKDPFS	0x400		/* Lock daemon in place */

#define MI_INTR		0x800		/* FS hardmount is interruptible. */
#define	MI_DOWN		0x1000		/* Mount server is down. */
#define MI_SYNC		0x2000		/* Perform synchronous writes */
#define	MI_CHARD	0x4000		/* CFS hardmount. */
#define	MI_CHARDDUP	0x8000		/* CFS hardmount + writes to server. */
#define MI_NOCNODECACHE	0x10000		/* don't cache cnodes */

/* separate data integrity mntinfo flags, not subject to vfs changes */
#define MI_DIHARD	0x20000		/* chard semantics */
#define MI_DIHARDDUP	0x40000		/* charddup semantics */

#define	MI_SYNCONCLOSE	0x80000		/* Sync-on-close. */

/* 
 * Fake errnos passed back by CFS ops; they are implicitly related
 * to ENFS_TRYAGAIN.
 */

#if defined(_KERNEL) && ENFS_TRYAGAIN != 999
#error CFS errnos may be incorrectly defined.
#endif

#define	ECFS_TRYAGAIN	(1000)
#define	ECFS_EOF	(1001)
#define	ECFS_TOKENRACE	(1002)
#define	ECFS_VFSDOWN	(1003)
#define	ECFS_NOFSHIP	(1004)

#endif	/* _NSC_CFE_CFS_CLNT_H */
