/*
#ident "@(#)$Header: /src/nsc_uw7/usr/src/nsc/uts/fs/nsc_cfs/cms_flags.h,v 3.6 2000/03/06 06:04:38 zabby Exp $"
 */

#ifndef _NSC_CFE_CMS_FLAGS_H
#define _NSC_CFE_CMS_FLAGS_H

#ifndef _KERNEL_HEADERS
#ifndef NOT_NSC
#include <sys/nsc_defines.h>
#endif /* !NOT_NSC */
#endif /* !_KERNEL_HEADERS */

/*
 *  Flag definitions for the cms_mntinfo_t mi_flags and
 *  cmssvr_dbentry_t db_flags.
 */

#define CMS_EXPORT	0x01	/* This FS is exportable to remote clusters */
#define CMS_REMOTE	0x02	/* This FS is on a remote cluster */
#define CMS_SUBMOUNTS	0x04	/* This (remote) FS will follow submounts */
#define CMS_VFS_DOWN	0x08	/* Down. */
#define CMS_DYNAMIC	0x10	/* This (remote) FS was set up dynamically */
#define	CMS_SKIPDEV	0x20	/* Skip device unique check in mount. */
#define	CMS_ISLOCAL	0x40	/* Start unmounts locally. */
#define	CMS_TMPVFS	0x80	/* Forget CFS VFS if the server goes down. */

#define CMS_ASSIGNED	0x100	/* Fsid is assigned, but not mounted. */
#define CMS_INVALID	0x200	/* Fsid is invalid. */
#define CMS_REMOVED	0x400	/* Entry is removed from the database. */

#ifdef NSC_EXNFS
#define CMS_ISEXPORTED 	0x800	/* This mount is externally exported */
#endif

#define	CMS_BCDOWN	0x1000	/* Back-up cache has gone down */

#define CMS_DB_INFLAGS_MASK	0xFF	/* Mask for imported flags */

#endif	/* _NSC_CFE_CMS_FLAGS_H */
