#ifndef _SVC_KEYCTL_H   /* wrapper symbol for kernel use */
#define _SVC_KEYCTL_H   /* subject to change without notice */

#ident	"@(#)unixsrc:usr/src/common/uts/svc/keyctl.h /main/uw7_nj/1"
#ident  "$Header: /src/nsc_uw7/usr/src/common_nsc/uts/svc/keyctl.h,v 1.6 2000/03/06 05:55:53 zabby Exp $"

#if defined(__cplusplus)
extern "C" {
#endif

#ifdef _KERNEL_HEADERS

#include <util/types.h> /* REQUIRED */

#elif defined(_KERNEL) || defined(_KMEMUSER)

#include <sys/types.h> /* REQUIRED */
#ifndef NOT_NSC
#include <sys/nsc_defines.h>
#endif /* !NOT_NSC */

#endif /* _KERNEL_HEADERS */

/* 
 * Definition of current actions supported by the keyctl() system call
 */
#define K_SETLIMIT	0x00010000
#define K_GETLIMIT	0x00020000
#define K_INCRUSE	0x00030000
#define K_DECRUSE	0x00040000
#define K_PINCRUSE	0x00050000
#define	K_VALIDATE	0x00060000

/*
 * Definition of resources currently controlled via the keyctl() system call
 * 
 */
#define K_USER		0x00000000
#define K_PROC		0x00000001

#define K_ACTIONMASK	0xFFFF0000
#define K_RESOURCEMASK	0x0000FFFF

#define K_GETPROCLIMIT	(K_GETLIMIT | K_PROC)
#define K_GETUSERLIMIT	(K_GETLIMIT | K_USER)
#define K_SETPROCLIMIT	(K_SETLIMIT | K_PROC)
#define K_SETUSERLIMIT	(K_SETLIMIT | K_USER)
#define K_INCRCURNUSER	(K_INCRUSE  | K_USER)
#define K_PINCRCURNUSER	(K_PINCRUSE | K_USER)
#define K_DECRCURNUSER	(K_DECRUSE  | K_USER)

#ifdef NSC_XXX /* Not sure what to do yet for UW7 */

#define K_CLUSTER	0x00000002
#define K_GETCLUSTERLIMIT	(K_GETLIMIT | K_CLUSTER)
#define K_SETCLUSTERLIMIT	(K_SETLIMIT | K_CLUSTER)
#endif /* NSC_XXX */

#define	MAXSKEYS	256
#define K_UNLIMITED	0xEFFF

#define TYPELEN	15
#define SNLEN	10
#define STRLEN	16
#define SKLEN	8

struct k_skey {
	uchar_t	sernum[STRLEN];	/* serial number */
	uchar_t	serkey[STRLEN];	/* serial key */
};

typedef struct k_skey k_skey_t;

#if defined(__cplusplus)
	}
#endif

#endif /* _SVC_KEYCTL_H */
