#ident "@(#)$Header: /src/nsc_uw7/usr/src/nsc/uts/nsc/nsc_config.h,v 3.5 2000/03/06 06:09:44 zabby Exp $"

#ifndef _NSC_GENERIC_NSC_CONFIG_H
#define _NSC_GENERIC_NSC_CONFIG_H

#ifdef _KERNEL_HEADERS
#include <util/param.h>
#else
#include <sys/param.h>
#endif



/* define the maximum clusternode_t value actually supported, i.e. each
 * subsystem must be able to manage/allocate for nodes 1 - NSC_MAX_NODE_VALUE.
 * Should be a runtime value, but that requires more support not yet 
 * available to a) dynamically size all relevant data structures and b)
 * make sure root node's value is passed to joining nodes, and
 * supersedes their own.
 * When changing this value, please be aware of the limits specified below
 */
#ifdef NSC_UW7
/*
 * NSC_XXX: The restriction to 15 nodes is to avoid having the device
 *	    number go negative.
 */
#define NSC_MAX_NODE_VALUE  15
#elif NSC_UW || NSC_TNC	/* Regroup only supports 16 nodes at present. */
#define NSC_MAX_NODE_VALUE  16
#else
#define NSC_MAX_NODE_VALUE  32
#endif

/* Define the part of the pid_t reserved for clusternode_t values.
 * Needed regardless of VPROC support in order to generate NSC_NODE_T_RANGE_MAX
 */
#define NODESHIFT	16	/* used by VPROC */

#if !defined(_DDI)
/* derive the maximum valid clusternode_t value, used ONLY for data-type 
 * range checking 
 * The MAXPID defined in common/uts/util/param.h provides a limit to the 
 * number of nodes that can be operating at one time. 
 */
#define NSC_NODE_T_RANGE_MAX    (MAXPID >> NODESHIFT)

#if NSC_MAX_NODE_VALUE > NSC_NODE_T_RANGE_MAX
	#error "NSC_MAX_NODE_VALUE is too large to fit into pid number"
#endif
#endif /* !_DDI */


/* CMS and CSPECFS components place a restriction on the maximum number of
 * nodes operating at one time.  The limitation is due to the fsid creations,
 * since the node number is included in the physical devices major number.
 * Currently, in Unixware there are 5 bits left over for the node number.
 * Which allows CMS to run on maximum of 31 nodes.
 * The limit is set in i386/uts/util/sysmacros_f.h file as L_BITSNODE and
 * L_MAXNODE.
 */

/* Namefs component places a restriction on the maximum number of nodes
 * operating at one time. The limitation is due to the inode number.  The
 * inode number takes 8 bits, so there are currently 24 bits left over
 * for the node number.
 * The limits are set in common/uts/fs/namefs/namesubr.c and namenode.h
 * files as NMNODEBITS 
 */

#endif /* _NSC_GENERIC_NSC_CONFIG_H */
