#ifndef _SVC_SYSTEMINFO_H	/* wrapper symbol for kernel use */
#define _SVC_SYSTEMINFO_H	/* subject to change without notice */

#ident	"@(#)unixsrc:usr/src/common/uts/svc/systeminfo.h /main/uw7_nj/1"
#ident	"$Header: /src/nsc_uw7/usr/src/common_nsc/uts/svc/systeminfo.h,v 1.3 2000/03/06 05:55:54 zabby Exp $"

#if defined(__cplusplus)
extern "C" {
#endif

#ifndef NOT_NSC
#include <sys/nsc_defines.h>
#endif /* !NOT_NSC */

#ifdef _KERNEL
extern char srpc_domain[];
#endif /* _KERNEL */

/*
 * Commands to sysinfo(2).
 * Additions to this list should be reflected in truss(1).
 *
 * The __O_SI_XXX names represent commands that have been assigned
 * new numbers; these names are strictly for use in compatibility code.
 */

#define __O_SI_SYSNAME		1	/* return name of operating system */
#define __O_SI_HOSTNAME		2	/* return name of node */
#define SI_RELEASE 		3	/* return release of operating system */
#define SI_VERSION		4	/* return version field of utsname */
#define __O_SI_MACHINE		5	/* return kind of machine */
#define __O_SI_ARCHITECTURE	6	/* return instruction set arch */
#define SI_HW_SERIAL		7	/* return hardware serial number */
#define __O_SI_HW_PROVIDER	8	/* return hardware manufacturer */
#define SI_SRPC_DOMAIN		9	/* return secure RPC domain */
#define SI_INITTAB_NAME		10	/* return name of inittab file used */
#define SI_ARCHITECTURE		100	/* return instruction set arch */
#define SI_BUSTYPES		101	/* return list of bus types */
#define SI_HOSTNAME		102	/* return fully-qualified node name */
#define SI_HW_PROVIDER		103	/* return hardware manufacturer */
#define SI_KERNEL_STAMP		104	/* return kernel generation timestamp */
#define SI_MACHINE		105	/* return kind of machine */
#define SI_OS_BASE		106	/* return base operating system */
#define SI_OS_PROVIDER		107	/* return operating system provider */
#define SI_SYSNAME		108	/* return name of operating system */
#define SI_USER_LIMIT		109	/* return maximum number of users */
/*
 * These commands are unpublished interfaces to sysinfo(2).
 */
#define __O_SI_SET_HOSTNAME	258	/* set name of node */
					/*  -unpublished option */
#define SI_SET_HOSTNAME		259	/* set fully-qualified host name */
					/*  -unpublished option */
#define SI_SET_SRPC_DOMAIN	265	/* set secure RPC domain */
					/*  -unpublished option */
#ifdef NSC
#define SI_CLUSTER_RELEASE	270	/* get the cluster software */
					/* release version */
					/*  -unpublished option */
#endif

#if defined(__STDC__) && !defined(_KERNEL)
int sysinfo(int, char *, long);
#endif

#if defined(__cplusplus)
	}
#endif

#endif /* _SVC_SYSTEMINFO_H */
