#ident "@(#)$Header: /src/nsc_uw7/usr/src/nsc/uts/nsc/tnc_types.h,v 3.2 2000/03/10 15:29:38 zabby Exp $"

/*
 * Copyright 2000 Compaq Computer Corporation
 *        All Rights Reserved
 */

/*
 * This is a compatability header for older user applications.
 * The definitions provided by this header should be considered
 * deprecated.  User apps should be changed to use the more
 * modern definitions.
 *
 *	node_t		---->		clusternode_t
 *	THIS_NODE	---->		CLUSTERNODE_THIS
 *	BEST_NODE	---->		CLUSTERNODE_BEST
 *	NODEINVAL	---->		CLUSTERNODE_INVAL
 */

#ifndef _NSC_TNC_TYPES_H
#define _NSC_TNC_TYPES_H

#ifdef _KERNEL_HEADERS
#error "It is illegal for kernel code to include nsc/tnc_types.h"
#elif defined(_KERNEL) || defined(_KMEMUSER)
#error "It is illegal for space.c or KMEMUSER code to include sys/tnc_types.h"
#endif


/*
 * Include sys/types.h which contains the definition of clusternode_t
 * and the CLUSTERNODE_THIS, CLUSTERNODE_BEST, and CLUSTERNODE_INVAL
 * values.
 */
#include <sys/types.h>

typedef clusternode_t node_t;

#define THIS_NODE	CLUSTERNODE_THIS
#define BEST_NODE	CLUSTERNODE_BEST
#define NODEINVAL	CLUSTERNODE_INVAL


/*
 * We define these twice to force a compiler warning message so
 * we can inform the user that these definitions are deprecated.
 * Not an ideal way of causing a warning, but our compiler
 * environment doesn't provide an alternative.
 */
#define sys_tnc_types_h_is_obsolete 1
#define sys_tnc_types_h_is_obsolete 2
#undef  sys_tnc_types_h_is_obsolete
#define use_sys_types_h_instead 1
#define use_sys_types_h_instead 2
#undef  use_sys_types_h_instead
#define node_t_is_obsolete 1
#define node_t_is_obsolete 2
#undef  node_t_is_obsolete
#define use_clusternode_t_instead 1
#define use_clusternode_t_instead 2
#undef  use_clusternode_t_instead
#define THIS_NODE_is_obsolete 1
#define THIS_NODE_is_obsolete 2
#undef  THIS_NODE_is_obsolete
#define use_CLUSTERNODE_THIS_instead 1
#define use_CLUSTERNODE_THIS_instead 2
#undef  use_CLUSTERNODE_THIS_instead
#define BEST_NODE_is_obsolete 1
#define BEST_NODE_is_obsolete 2
#undef  BEST_NODE_is_obsolete
#define use_CLUSTERNODE_BEST_instead 1
#define use_CLUSTERNODE_BEST_instead 2
#undef  use_CLUSTERNODE_BEST_instead
#define NODEINVAL_is_obsolete 1
#define NODEINVAL_is_obsolete 2
#undef  NODEINVAL_is_obsolete
#define use_CLUSTERNODE_INVAL_instead 1
#define use_CLUSTERNODE_INVAL_instead 2
#undef  use_CLUSTERNODE_INVAL_instead

#endif /* !_NSC_TNC_TYPES_H */
