#ifndef _PROC_UNISTD_H	/* wrapper symbol for kernel use */
#define _PROC_UNISTD_H	/* subject to change without notice */

#ident	"@(#)unixsrc:usr/src/common/uts/proc/unistd.h /main/uw7_nj/5"
#ident	"$Header: /src/nsc_uw7/usr/src/common_nsc/uts/proc/unistd.h,v 1.8 2000/03/07 01:54:02 zabby Exp $"

#if defined(__cplusplus)
extern "C" {
#endif

#ifndef NOT_NSC
#ifndef _KERNEL_HEADERS
#include <sys/nsc_defines.h>
#endif
#endif /* !NOT_NSC */

/*
 * WARNING: This is an implementation-specific header,
 * its contents are not guaranteed. Applications
 * should include <unistd.h> and not this header.
 */

/* Symbolic constants for the 'access' routine: */
#define R_OK    004       /* Test for Read permission */
#define W_OK    002       /* Test for Write permission */
#define X_OK    001       /* Test for eXecute permission */
#define F_OK    000       /* Test for existence of File */

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) \
	&& !defined (_POSIX_C_SOURCE) || defined(_KERNEL)
#define EFF_ONLY_OK	010	/* Test using effective ids */
#define EX_OK		020	/* Test for Regular, executable file */
#endif

/* Symbolic constants for the "lseek" routine: */
#ifndef SEEK_SET
#define SEEK_SET        0       /* Set file pointer to "offset" */
#define SEEK_CUR        1       /* Set file pointer to current plus "offset" */
#define SEEK_END        2       /* Set file pointer to EOF plus "offset" */
#endif  /* SEEK_SET */

#define _SC_ARG_MAX	1
#define _SC_CHILD_MAX	2
#define _SC_CLK_TCK	3
#define _SC_NGROUPS_MAX 4
#define _SC_OPEN_MAX	5
#define _SC_JOB_CONTROL 6
#define _SC_SAVED_IDS	7
#define _SC_VERSION	8
#define _SC_PASS_MAX	9
#define _SC_LOGNAME_MAX	10
#define _SC_PAGESIZE	11
#define _SC_PAGE_SIZE	_SC_PAGESIZE
#define _SC_XOPEN_VERSION 12
#define _SC_NACLS_MAX   13
#define _SC_NPROCESSORS_CONF	14
#define _SC_NPROCESSORS_ONLN	15
#define _SC_NPROCESSES	39		   
#define _SC_TOTAL_MEMORY	40
#define _SC_USEABLE_MEMORY	41
#define _SC_GENERAL_MEMORY	42
#define _SC_DEDICATED_MEMORY	43
#define _SC_NCGS_CONF		44
#define _SC_NCGS_ONLN		45
#define _SC_MAX_CPUS_PER_CG	46
#define _SC_CG_SIMPLE_IMPL	47
#define _SC_CACHE_LINE		48
#define _SC_SYSTEM_ID		49
#define _SC_THREADS		51
#define _SC_THREAD_ATTR_STACKADDR	52
#define _SC_THREAD_ATTR_STACKSIZE	53
#define _SC_THREAD_DESTRUCTOR_ITERATIONS	54
#define _SC_THREAD_KEYS_MAX		55
#define _SC_THREAD_PRIORITY_SCHEDULING	56
#define _SC_THREAD_PRIO_INHERIT		57
#define _SC_THREAD_PRIO_PROTECT		58
#define _SC_THREAD_STACK_MIN		59
#define _SC_THREAD_PROCESS_SHARED	60
#define _SC_THREAD_SAFE_FUNCTIONS	61
#define _SC_THREAD_THREADS_MAX		62
#define _SC_KERNEL_VM		63
#define _SC_TZNAME_MAX	320
#define _SC_STREAM_MAX	321
#define _SC_XOPEN_CRYPT	323
#define _SC_XOPEN_ENH_I18N	324
#define _SC_XOPEN_SHM	325
#define _SC_XOPEN_XCU_VERSION	327
#define _SC_AES_OS_VERSION	330
#define _SC_ATEXIT_MAX	331
#define _SC_2_C_BIND	350
#define _SC_2_C_DEV	351
#define _SC_2_C_VERSION	352
#define _SC_2_CHAR_TERM	353
#define _SC_2_FORT_DEV	354
#define _SC_2_FORT_RUN	355
#define _SC_2_LOCALEDEF	356
#define _SC_2_SW_DEV	357
#define _SC_2_UPE	358
#define _SC_2_VERSION	359
#define _SC_BC_BASE_MAX	370
#define _SC_BC_DIM_MAX	371
#define _SC_BC_SCALE_MAX	372
#define _SC_BC_STRING_MAX	373
#define _SC_COLL_WEIGHTS_MAX	380
#define _SC_EXPR_NEST_MAX	381
#define _SC_LINE_MAX	382
#define _SC_RE_DUP_MAX	383
#define _SC_IOV_MAX		390	
#define _SC_NPROC_CONF		391	/* 4.0MP COMPAT */
#define _SC_NPROC_ONLN		392	/* 4.0MP COMPAT */

/* X/Open UNIX additions */

#define _SC_XOPEN_UNIX	400

#define _SC_SEMAPHORES	440

/* command names for XPG4 confstr */

#define _CS_PATH		1
#define __O_CS_HOSTNAME		2	/* name of node (old) */
#define _CS_RELEASE 		3	/* release of operating system */
#define _CS_VERSION		4	/* version field of utsname */
#define __O_CS_MACHINE		5	/* kind of machine (old) */
#define __O_CS_ARCHITECTURE	6	/* instruction set arch (old) */
#define _CS_HW_SERIAL		7	/* hardware serial number */
#define __O_CS_HW_PROVIDER	8	/* hardware manufacturer (old) */
#define _CS_SRPC_DOMAIN		9	/* secure RPC domain */
#define _CS_INITTAB_NAME	10	/* name of inittab file used */
#define __O_CS_SYSNAME		11	/* name of operating system (old) */

#define _CS_LFS_CFLAGS		20	/* LFS cc(1) and lint(1) flags */
#define _CS_LFS_LDFLAGS		21
#define _CS_LFS_LIBS		22
#define _CS_LFS_LINTFLAGS	23
#define _CS_LFS64_CFLAGS	24
#define _CS_LFS64_LDFLAGS	25
#define _CS_LFS64_LIBS		26
#define _CS_LFS64_LINTFLAGS	27

#define _CS_ARCHITECTURE	100	/* instruction set arch */
#define _CS_BUSTYPES		101	/* list of bus types */
#define _CS_HOSTNAME		102	/* fully-qualified node name */
#define _CS_HW_PROVIDER		103	/* hardware manufacturer */
#define _CS_KERNEL_STAMP	104	/* kernel generation timestamp */
#define _CS_MACHINE		105	/* kind of machine */
#define _CS_OS_BASE		106	/* base operating system */
#define _CS_OS_PROVIDER		107	/* operating system provider */
#define _CS_SYSNAME		108	/* name of operating system */
#define _CS_USER_LIMIT		109	/* maximum number of users */

/* command names for POSIX pathconf */

#define _PC_LINK_MAX	1
#define _PC_MAX_CANON	2
#define _PC_MAX_INPUT	3
#define _PC_NAME_MAX	4
#define _PC_PATH_MAX	5
#define _PC_PIPE_BUF	6
#define _PC_NO_TRUNC	7
#define _PC_VDISABLE	8
#define _PC_CHOWN_RESTRICTED	9
#define _PC_FILESIZEBITS	10
#ifdef NSC
#define _PC_NSC_OBJSVRNODE	411
#define _PC_TNC_OBJSVRNODE	_PC_NSC_OBJSVRNODE	/* for ompatability */
#endif

#ifndef _POSIX_VERSION
#define _POSIX_VERSION	199009L
#endif

#ifndef _XOPEN_VERSION
#define _XOPEN_VERSION 4
#endif

#if defined(__cplusplus)
        }
#endif
#endif /* _PROC_UNISTD_H */
