#ifndef _SVC_UTSSYS_H	/* wrapper symbol for kernel use */
#define _SVC_UTSSYS_H	/* subject to change without notice */

#ident	"@(#)unixsrc:usr/src/common/uts/svc/utssys.h /main/uw7_nj/1"
#ident	"$Header: /src/nsc_uw7/usr/src/common_nsc/uts/svc/utssys.h,v 1.6 2000/03/06 05:55:57 zabby Exp $"

#if defined(__cplusplus)
extern "C" {
#endif

/*
 * Definitions related to the utssys() system call. 
 */

#ifdef _KERNEL_HEADERS

#include <util/types.h>	/* REQUIRED */

#elif defined(_KERNEL) || defined(_KMEMUSER)

#include <sys/types.h>	/* REQUIRED */
#ifndef NOT_NSC
#include <sys/nsc_defines.h>
#endif /* !NOT_NSC */

#endif /* _KERNEL_HEADERS */

/*
 * "commands" of utssys
 */
#define UTS_UNAME	0x0
#define UTS_USTAT	0x2	/* 1 was umask */
#define UTS_FUSERS	0x3
/* Enhanced Application Compatibility Support */
#define UTS_SCO_USTAT32	0x3	/*overlap with UTS_FUSERS */
/* End Enhanced Application Compatibility Support */
#define UTS_GETENG	0x4

/*
 * Tandem added "commands"
 */
#ifdef NSC_YAPM_DOCALLS
#define TANDEM_YAPM_START       100     /* turn on yapm monitor */
#define TANDEM_YAPM_USERLOG     101     /* user generated log call */
#endif /* NSC_YAPM_DOCALLS */

#ifdef NSC_ACCIDLE
#define TANDEM_IDLE_CLEAR       102     /* clear tandem special idle counters */
#define TANDEM_IDLE_SNAP        103     /* read tandem special idle counters */
#endif /* NSC_ACCIDLE */

#ifdef NSC_YAPM_DOCALLS
#define TANDEM_YAPM_PREALLOC    104     /* pre-allocate yapm buffers */
#endif /* NSC_YAPM_DOCALLS */

/*
 * Flags to UTS_FUSERS.
 */
#define F_FILE_ONLY	0x1
#define F_CONTAINED	0x2

/*
 * Structure yielded by UTS_FUSERS:
 */
typedef struct f_user {
	pid_t	fu_pid;		/* pid of process using file. */
	int	fu_flags;	/* see below. */
	uid_t	fu_uid;		/* real uid of process using file. */
} f_user_t;

/*
 * fu_flags values:
 */
#define F_CDIR		0x1	/* current directory */
#define F_RDIR		0x2	/* root directory */
#define F_TEXT		0x4	/* a.out */
#define F_MAP		0x8	/* mapped file (unsupported) */
#define F_OPEN		0x10	/* open file */
#define F_TRACE		0x20	/* /proc vnode */
#define F_TTY		0x40	/* controlling terminal */

#if defined(__cplusplus)
	}
#endif

#endif /* _SVC_UTSSYS_H */ 
