/* @(#)unixsrc:usr/src/common/lib/libvxvm/unixware/libvxvm/volclient_sys.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/lib/libvxvm/unixware/libvxvm/volclient_sys.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VOLCLIENT_SYS_H
#define _VOLCLIENT_SYS_H

#include <sys/types.h>
#include <volipc.h>

/*
 * volclient_sys.h - volume manager client side system dependent header file
 *
 * This file contains data specific to the client side of the volume
 * manager library interface.
 */

/* directory that contains usage type utilities */
#define VOL_UT_DIR	"/usr/lib/vxvm/type"

#define	VOLINFO_UTIL	"vxinfo"
#define	VOLMAKE_UTIL	"vxmake"
#define VOLMEND_UTIL	"vxmend"
#define	VOLPLEX_UTIL	"vxplex"
#define	VOLSD_UTIL	"vxsd"
#define	VOLUME_UTIL	"vxvol"
#define VOLEDIT_UTIL	"vxedit"
#define VOLD_UTIL	"vxconfigd"

#define VOL_ADMIN_DIR	"/usr/sbin"

#define VOL_SCRIPTS_DIR	"/usr/lib/vxvm/bin"

#define VOL_DIAGBIN_DIR	"/etc/vx/diag.d"

#define VOL_ROOT_DIR_LEN	60

/* maximum possible length for a path to a usage type utility */
#define VOL_UT_LEN	(VOL_ROOT_DIR_LEN + sizeof(VOL_UT_DIR) + NAME_LEN + \
			 sizeof("//verylongutilityname"))

/*
 * Define platform dependent Volume Manager device interface
 */

typedef int  voldevfd_t;

#define VOL_INVALID_DEVFD       -1
#define VOL_DEVOPEN(dev)	open((dev), O_RDWR)
#define VOL_DEVIOCTL(fd, cmd, arg) \
				ioctl((fd), (cmd), (arg))
#define VOL_DEVCLOSE(fd)        close((fd))

#define VOL_CONFIG_DEVICE       "/dev/vx/config"
#define VOL_INFO_DEVICE         "/dev/vx/info"
#define VOL_IOD_DEVICE          "/dev/vx/iod"
#define VOL_TRACE_DEVICE        "/dev/vx/trace"

#define VOL_DEVICE_DIR		"/dev/vx/dsk"
#define VOL_RDEVICE_DIR		"/dev/vx/rdsk"

#define STRERROR(err)		strerror((err))

/*
#define HZ    			((int)sysconf(_SC_CLK_TCK))
*/


/*
 * UnixWare needs a special minor number for swapvol.
 */
#define FORCE_SWAP_MINOR

#endif /* _VOLCLIENT_SYS_H */
