/* @(#)unixsrc:usr/src/common/lib/libvxvm/common/libvxvm/voldctl.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/lib/libvxvm/common/libvxvm/voldctl.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VOLDCTL_H
#define _VOLDCTL_H

/*
 * vold control operations
 */

struct voldctl_hostid_req {
	size_t hostid_size;
	char hostid[1/*hostid_size*/];
};

struct voldctl_add_disk_req {
	char name[NAME_SZ];
	char type[DA_TYPE_SZ];
	size_t attrsize;
	char attrbuf[1/*attrsize*/];
};

struct voldctl_rm_disk_req {
	char name[NAME_SZ];
};

struct voldctl_op_req {
	int op;
	size_t reqsize;
	char reqbuf[1/*reqsize*/];
};

struct volboot_contents {
	size_t		_vbc_baselen;
	int		vbc_version_major;
	int		vbc_version_minor;
	volseqno_t	vbc_update_seqno;
	char	       *vbc_hostid;
	size_t		vbc_nentry;
	union volboot_entry **vbc_entries;
};

union volboot_entry {
	int	vbe_type;
	struct {
		int	vbe_type;
		size_t	_vbe_entry_size;
	} _vbe;
	struct volboot_disk {
		int	vbe_type;
		size_t	_vbe_entry_size;
		char	vbe_disk_name[NAME_SZ];
		char	vbe_disk_type[DA_TYPE_SZ];
		char	vbe_disk_info[1/*variable*/];
	} vbe_disk;
};
#define VOLBOOT_DISK		1	/* disk device */

#if defined(__STDC__)
extern int   voldctl_init(const char *);
extern int   voldctl_hostid(const char *);
extern int   voldctl_add_disk(const char *, const char *, const char *, size_t);
extern int   voldctl_rm_disk(const char *);
extern int   voldctl_vold_status(void);
extern int   voldctl_vold_enable(void);
extern int   voldctl_vold_disable(void);
extern int   voldctl_vold_stop(void);
extern int   voldctl_vold_license_check(void);
extern struct volboot_contents *voldctl_get_volboot(void);
extern int   voldctl_op(int, const void *, size_t);
extern VOID *voldctl_query(int, const void *, size_t);
#else	/* not __STDC__ */
extern int   voldctl_init();
extern int   voldctl_hostid();
extern int   voldctl_add_disk();
extern int   voldctl_rm_disk();
extern int   voldctl_vold_status();
extern int   voldctl_vold_enable();
extern int   voldctl_vold_disable();
extern int   voldctl_vold_stop();
extern int   voldctl_vold_license_check();
extern struct volboot_contents *voldctl_get_volboot();
extern int   voldctl_op();
extern VOID *voldctl_query();
#endif	/* __STDC__ */

#endif	/* _VOLDCTL_H */
