/* @(#)unixsrc:usr/src/common/lib/libvxvm/common/libvxvm/volnotify.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/lib/libvxvm/common/libvxvm/volnotify.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VOLNOTIFY_H
#define _VOLNOTIFY_H

/*
 * structures used with vol_notify library functions
 */

typedef enum vol_note_type {
	MIN_VOL_NOTE_TYPE,	/* sentinal value, must be first */
	VOL_NOTE_MORE,		/* some events were lost */
	VOL_NOTE_DG_IMPORT,	/* a new disk group was imported */
	VOL_NOTE_DG_DEPORT,	/* a disk group was deported */
	VOL_NOTE_DG_DISABLE,	/* a disk group was disabled */
	VOL_NOTE_DG_ENABLE,	/* a disk group was enabled */
	VOL_NOTE_DG_CHANGE,	/* a disk group was changed */
	VOL_NOTE_PLEX_DETACH,	/* a plex was detached by a failure */
	VOL_NOTE_VOL_DETACH,	/* a volume was detached by a failure */
	VOL_NOTE_DISK_DETACH,	/* a disk was detached by a failure */
	VOL_NOTE_DISK_CHANGE,	/* a disk was changed */
	VOL_NOTE_VOLD_DISABLE,	/* vold changed to disabled state */
	VOL_NOTE_VOLD_ENABLE,	/* vold changed to enabled state */
	VOL_NOTE_SD_DETACH,	/* subdisk detached */
	VOL_NOTE_SD_RELOCATE,	/* subdisk needs relocation */
	VOL_NOTE_VOL_DEGRADED,	/* RAID 5 volume now in degraded mode */
	VOL_NOTE_VOL_LOG_DETACH, /* volume log detached */
	MAX_VOL_NOTE_TYPE	/* sentinal value, must be last */
} vol_note_type_t;

union vol_notify {
	vol_note_type_t		note_type;
	struct note_dg_import {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
	} note_dg_import;
	struct note_dg_deport {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
	} note_dg_deport;
	struct note_dg_disable {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
	} note_dg_disable;
	struct note_dg_change {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
	} note_dg_change;
	struct note_plex_detach {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_plex_name[NAME_SZ];
		char		note_vol_name[NAME_SZ];
		volrid_t	note_plex_rid;
		volrid_t	note_vol_rid;
	} note_plex_detach;
	struct note_vol_detach {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_vol_name[NAME_SZ];
		volrid_t	note_vol_rid;
	} note_vol_detach;
	struct note_disk_detach {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_da_name[NAME_SZ];
		char		note_dm_name[NAME_SZ];
		volrid_t	note_da_rid;
		volrid_t	note_dm_rid;
	} note_disk_detach;
	struct note_disk_change {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_disk_seqno;
		char		note_da_name[NAME_SZ];
		char		note_dm_name[NAME_SZ];
		volrid_t	note_da_rid;
		volrid_t	note_dm_rid;
	} note_disk_change;
	struct note_sd_detach {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_sd_name[NAME_SZ];
		char		note_plex_name[NAME_SZ];
		char		note_vol_name[NAME_SZ];
		volrid_t	note_sd_rid;
		volrid_t	note_plex_rid;
		volrid_t	note_vol_rid;
	} note_sd_detach;
	struct note_sd_relocate {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_sd_name[NAME_SZ];
		char		note_plex_name[NAME_SZ];
		char		note_vol_name[NAME_SZ];
		volrid_t	note_sd_rid;
		volrid_t	note_plex_rid;
		volrid_t	note_vol_rid;
	} note_sd_relocate;
	struct note_vol_degraded {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_vol_name[NAME_SZ];
		volrid_t	note_vol_rid;
	} note_vol_degraded;
	struct note_vol_log_detach {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
		char		note_vol_name[NAME_SZ];
		volrid_t	note_vol_rid;
	} note_vol_log_detach;
	struct note_event {
		vol_note_type_t	note_type;
		volrid_t	note_import_id;
		char		note_dgid[VOL_UUID_SZ];
		char		note_dg_name[NAME_SZ];
		volseqno_t	note_config_tid;
	} note_event;
};

/*
 * bits defining desired events
 */

#define VOL_NOTE_WANT_DG_LIST	  0x0001	/* want dg list changes */
#define VOL_NOTE_WANT_DG_CHANGE   0x0002	/* want dg config changes */
#define VOL_NOTE_WANT_DETACH	  0x0004	/* want plex/volume detaches */
#define VOL_NOTE_WANT_DISK_CHANGE 0x0008	/* want disk config changes */

#define VOL_NOTE_WANT_ALL \
	(VOL_NOTE_WANT_DG_LIST | VOL_NOTE_WANT_DG_CHANGE |	\
	 VOL_NOTE_WANT_DETACH | VOL_NOTE_WANT_DISK_CHANGE )

#if defined(__STDC__)
extern int vol_notify_open(void);
extern void vol_notify_close(void);
extern int vol_notify_reconnect(void);
extern int vol_notify_setup(ulong_t);
extern union vol_notify *vol_notify_handle(void);
#else	/* not __STDC__ */
extern int vol_notify_open();
extern void vol_notify_close();
extern int vol_notify_reconnect();
extern int vol_notify_setup();
extern union vol_notify *vol_notify_handle();
#endif	/* __STDC__ */

#endif	/* _VOLNOTIFY_H */
