/* @(#)unixsrc:usr/src/common/uts/io/vxvm/common/voldbioctl.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/common/voldbioctl.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLDBIOCTL_H

/*
 * voldbioctl.h - kernel ioctl interface for self-recovery applications
 */

/*
 * vol_mv_recov_mode - volume recovery mode
 */
typedef enum vol_mv_recov_mode {
	MIN_MR_MODE,
	VOL_MR_APPLICATION,
	VOL_MR_DEFAULT,
	MAX_MR_MODE
} vol_recov_mode_t;

/*
 * vol_mv_update_advisory - how to do DRL
 */
typedef enum vol_mv_update_advisory {
	MIN_VOL_ADVISE,
	VOL_ADVISE_DEFAULT,
	VOL_ADVISE_RANDOM,
	VOL_ADVISE_SEQUENTIAL,
	MAX_VOL_ADVISE
} vol_update_advisory_t;

/*
 * Ioctls for database support
 */
#define VOL_GET_MIRROR_RECOVERY_MODE	(VOLIOC | 90)
#define	VOL_SET_MIRROR_RECOVERY_MODE	(VOLIOC | 91)
#define	VOL_GET_RECOVER_SEQNO		(VOLIOC | 92)
#define	VOL_CLEAR_RECOVER_SEQNO		(VOLIOC | 93)
#define VOL_RECOVER_NEEDED		(VOLIOC | 94)
#define	VOL_RECOVER_COMPLETE		(VOLIOC | 95)
#define VOL_GET_UPDATE_ADVISORY		(VOLIOC | 96)
#define VOL_SET_UPDATE_ADVISORY		(VOLIOC | 97)

#define VOL_READ_MIRRORS		(VOLIOC | 99)

/*
 * VOL_MR_SQ_SIZE - number of bytes to store the sequence information for
 * 		    the VOL_READ_MIRRORS ioctl.
 * VOL_MR_NAME_SZ - number of chars for storing a name
 */
#define VOL_MR_SQ_SZ	((size_t)16)
#define VOL_MR_NAME_SZ	NAME_SZ

/*
 * vol_mirror_read - structure to iteratively read all mirrors in volume
 */
struct vol_mirror_read {
	volflag_t	mr_flags;		/* flags */
	voff_t		mr_off;			/* offset into volume */
	size_t		mr_size;		/* count of sectors to read */
	void		*mr_addr;		/* buffer to put data */
	char		mr_sequence[VOL_MR_SQ_SZ]; /* sequence data */
	char		mr_mirror_name[VOL_MR_NAME_SZ]; /* name of mirror */
};
#endif	/* _VXVM_VOLDBIOCTL_H */
