/* @(#)unixsrc:usr/src/common/uts/io/vxvm/common/voldcompat.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/common/voldcompat.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLDCOMPAT_H
#define _VXVM_VOLDCOMPAT_H

/*
 * voldcompat.h - VxVM 1.2 vold/kernel interface structures and ioctls
 *
 * This file contains variant structures that are needed by vold to
 * communicate with a VxVM 1.2 kernel.  Interfaces that are unchanged
 * between VxVM 1.2 and VxVM 2.0 are not listed in this file.
 */

#define VOL_GET_VOLUMES_12	(VOLIOC | 128)
#define VOL_DUMP_VOLUMES_12	(VOLIOC | 129)
#define VOL_DUMP_PLEXES_12	(VOLIOC | 130)
#define VOL_GET_PLEXES_12	(VOLIOC | 131)
#define VOL_DUMP_SUBDISKS_12	(VOLIOC | 132)
#define VOL_GET_SUBDISKS_12	(VOLIOC | 133)
#define VOL_GET_VOLUME_DEV_12	(VOLIOC | 143)
#define VOL_GET_PLEX_DEV_12	(VOLIOC | 144)

#define VOL_NEW_VOLUME_12	(VOLIOC | 135)
#define VOL_CHANGE_VOLUME_12	(VOLIOC | 136)
#define VOL_DELETE_VOLUME_12	(VOLIOC | 137)
#define VOL_LOAD_PLEX_12	(VOLIOC | 138)
#define VOL_LOAD_SUBDISK_12	(VOLIOC | 139)
#define VOL_ASSERT_VOLUME_12	(VOLIOC | 140)
#define VOL_ASSERT_PLEX_12	(VOLIOC | 141)
#define VOL_ASSERT_SUBDISK_12	(VOLIOC | 142)

/* ioctls against /dev/volconfig to suppot rootability */

#define	VOL_REPLACE_VOLUME_12	(VOLIOC | 180)

struct volkvol_12 {
	char			kv_name[NAME_SZ];	/* 0x00 */
	volrid_t		kv_rid;			/* 0x10 */
	voldevno_t		kv_dev;			/* 0x18 */
	voff_t			kv_len;			/* 0x1c */
	enum vol_r_pol		kv_read_pol;		/* 0x20 */
	volrid_t		kv_pref_plex;		/* 0x24 */
	enum vol_except		kv_r_all;		/* 0x2c */
	enum vol_except		kv_r_some;		/* 0x30 */
	enum vol_except		kv_w_all;		/* 0x34 */
	enum vol_except		kv_w_some;		/* 0x38 */
	enum vol_kstate		kv_kstate;		/* 0x3c */
	ulong_t			kv_kflag_12;		/* 0x40 */
	ulong_t			kv_sflag_12;		/* 0x44 */
	ulong_t			kv_vflag;		/* 0x48 */
	volseqno_t		kv_detach_tid_12;	/* 0x4c */
	ulong_t			kv_lasterr;		/* 0x54 */
	long			kv_log_serial_hi;	/* 0x58 */
	long			kv_log_serial_lo;	/* 0x5c */
	voff_t			kv_rwbackoff;		/* 0x60 read/writeback
								offset */
};							/* 0x64 */

/*
 * kernel flags set by vold
 */

#define V_KFLAG_WRITEBACK_12	0x000001	/* writeback error enabled */
#define V_KFLAG_WRITECOPY_12	0x000002	/* log blk #s being changed */
#define V_KFLAG_RWBACK_12	0x000004	/* read/writeback mode */
#define V_KFLAG_LOG_12		0x000008	/* volume requires logging */
#define V_KFLAG_LOGTYPE_12	0x0000f0	/* mask for log type */
#define V_KFLAG_LOGUNDEF_12	0x000000	/* default logging on volume */
#define V_KFLAG_LOGNONE_12	0x000010	/* no logging on volume */
#define V_KFLAG_LOGBLKNO_12	0x000020	/* log block #s being changed */
#define V_KFLAG_LOGCLEAR_12	0x000100	/* detached log record should 
							be cleared */

/*
 * volume status flags set by kernel
 */

#define V_SFLAG_OPEN_12		0x00000001	/* volume is open */
#define V_SFLAG_KDETACH_12	0x00000002	/* volume has been detached */
#define V_SFLAG_RWBACK_12	0x00000004	/* read/writeback mode */
#define V_SFLAG_LOGDETACH_12	0x00000008      /* logging for the volume has
							been disabled */


/* volume structure change bits */
struct volkvol_dump_12 {
	volrid_t	kvd_dgrid;		/* 0x00 disk group */
	size_t		kvd_cnt;		/* 0x08 struct count */
	struct volkvol_12 *kvd_ptr;		/* 0x0c user buf */
};						/* 0x10 */
struct volkvol_assert_12 {
	volrid_t	kva_rid;		/* 0x00 */
	enum vol_kstate	kva_kstate;		/* 0x08 */
	ulong_t		kva_sflag;		/* 0x0c */
	ulong_t		kva_lasterr;		/* 0x10 */
};						/* 0x14 */
struct volkplex_12 {
	char			kpl_name[NAME_SZ];		/* 0x00 */
	char			kpl_log_sd_name[NAME_SZ];	/* 0x0f */
	voldevno_t		kpl_dev;			/* 0x20 */
	volrid_t		kpl_rid;			/* 0x24 */
	volrid_t		kpl_volrid;			/* 0x2c */
	volrid_t		kpl_log_sdrid;			/* 0x34 */
	ulong_t			kpl_kflag_12;			/* 0x3c */
	ulong_t			kpl_sflag_12;			/* 0x40 */
	ulong_t			kpl_vflag;			/* 0x44 */
	enum vol_kstate		kpl_kstate;			/* 0x48 */
	enum plex_layout	kpl_layout;			/* 0x4c */
	voff_t			kpl_st_width;			/* 0x50 */
	volseqno_t		kpl_detach_tid_12;		/* 0x54 */
	ulong_t			kpl_lasterr;			/* 0x5c */
};								/* 0x60 */

/*
 * kernel plex flags set by vold
 */

#define PL_KFLAG_READ_12	0x01		/* 1=>read ops are allowed */
#define PL_KFLAG_WRITE_12	0x02		/* 1=>write ops are allowed */
#define PL_KFLAG_LOG_12		0x04		/* do update plex's log area */
#define PL_KFLAG_COMPLETE_12	0x08		/* plex is complete w.r.t. vp */
#define PL_KFLAG_NOERROR_12	0x10		/* 0=>participate in errors,
						 * 1=>don't participate */
#define PL_KFLAG_LOGCLEAR_12	0x20		/* klog entry for plex to be
						 * cleared */

#define PL_SFLAG_OPEN_12	0x01	/* plex is open */
#define	PL_SFLAG_KDETACH_12	0x02	/* plex has been detached */
#define PL_SFLAG_LOG_12		0x04	/* plex is logging */

struct volkplex_dump_12 {
	volrid_t	kpld_dgrid;		/* 0x00 */
	size_t		kpld_cnt;		/* 0x08 */
	struct volkplex_12 *kpld_ptr;		/* 0x0c */
};						/* 0x10 */
struct volkplex_assert_12 {
	volrid_t		kpla_rid;	/* 0x00 */
	volrid_t		kpla_volrid;	/* 0x08 */
	enum plex_kstate	kpla_kstate;	/* 0x10 */
	ulong_t			kpla_sflag;	/* 0x14 */
	ulong_t			kpla_lasterr;	/* 0x18 */
};						/* 0x1c */
struct volksd_12 {
	char			ksd_name[NAME_SZ];		/* 0x00 */
	volrid_t		ksd_rid;			/* 0x10 */
	volrid_t		ksd_drid;			/* 0x18 */
	volrid_t		ksd_plrid;			/* 0x20 */
	volrid_t		ksd_volrid;			/* 0x28 */
	ulong_t			ksd_kflag_12;			/* 0x30 */
	ulong_t			ksd_sflag_12;			/* 0x34 */
	ulong_t			ksd_vflag;			/* 0x38 */
	voff_t			ksd_offset;			/* 0x3c */
	voff_t			ksd_pl_offset;			/* 0x40 */
	voff_t			ksd_len;			/* 0x44 */
								/* 0x48 */
};

#define SD_KFLAG_LOG_12		0x00000001	/* subdisk is a log subdisk */

#define SD_SFLAG_LOG_12		0x00000001	/* subdisk is used as a log */
#define SD_SFLAG_OPEN_12	0x00000002	/* subdisk is open */

struct volksd_dump_12 {
	volrid_t	ksdd_dgrid;		/* 0x00 */
	size_t		ksdd_cnt;		/* 0x08 */
	struct volksd_12 *ksdd_ptr;		/* 0x0c */
};						/* 0x10 */
struct volksd_assert_12 {
	volrid_t	ksda_rid;		/* 0x00 */
	volrid_t	ksda_volrid;		/* 0x08 */
	ulong_t		ksda_sflag;		/* 0x10 */
	ulong_t		ksda_lasterr;		/* 0x14 */
};						/* 0x18 */

#endif	/* _VXVM_VOLDCOMPAT12_H */
