/* @(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/voldefault.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/voldefault.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLDEFAULT_H
#define _VXVM_VOLDEFAULT_H

/*
 * voldefault.h - default values for tunables
 *
 * Values in this file are defaults for values that can be configured
 * in the kernel configuration files.  The GET_VOLINFO ioctl should be
 * used to get the current values for these parameters, rather than
 * referencing the macros in this file.
 */

#if defined(UW_2_1) && !defined(MAXMIN)
#define MAXMIN  0x3ffff
#endif /* UW_2_1 && !MAXMIN */
#define	MAX_VOL		((MAXMIN+1)/2)	/* maximum allowed vol device number */
#define	MAX_PLEX		INT_MAX	/* maximum number of plexes allowed */
#define PLEX_NUM		32	/* max number of plexes in a volume */
#define SUBDISK_NUM		4096	/* max number of subdisks per plex */
#define	VOL_MAXIOCTL		32768	/* Max size of ioctl data (bytes) */
#define	VOL_MAXSPECIALIO	512	/* Max size of an I/O ioctl (sectors)*/
#define	VOL_MAXIO		512	/* Max I/O size (sectors) */
#define VOL_DEFAULT_IODELAY	50	/* dfl I/O delay for attaches (ticks)*/
#define VOL_MAXKIOCOUNT		2048	/* max # of concurrent I/Os */
#define VOLDRL_MAX_DRTREGS	2048	/* max # of DRL dirty regions */
#define VOLDRL_MIN_REGIONSZ	1024	/* min DRL region size */
#define VOL_MAXPARALLELIO	256	/* max # voldios allowed at one time */
#define VOL_MVR_MAXROUND	512	/* max round-robin region size */
#define VOL_MAXSTABLEBUFSIZE	256	/* max # blocks for stable buf copies*/
#define VOLIOT_IOBUF_LIMIT	131072	/* max total I/O trace buffer space */
#define VOLIOT_IOBUF_MAX	65536	/* max size of I/O trace buffer */
#define VOLIOT_IOBUF_DEFAULT	8192	/* default size of I/O trace buffer */
#define VOLIOT_ERRBUF_DEFAULT	16384	/* default size of error trace buffer*/
#define VOLIOT_MAX_OPEN		32	/* max # of trace channels */
#define	VOL_CHECKPT_DEFAULT	20480	/* default checkpt size of 64 M */
#define VOLRAID_RSRTRANSMAX	1	/* max # of transient RSRs */

#define	VOLIOMEM_KVMAP_SIZE (5*1024*1024) /* iomem virtual mapping length */
#define VOLIOMEM_CHUNK_SIZE  (64*1024)	/* get more I/O in multiples of this */
#define VOLIOMEM_BASE_MEMORY (512*1024)	/* base I/O memory in bytes */
#define VOLIOMEM_MAX_MEMORY (4*1024*1024) /* maximum memory for VxVM */
#define VOLDRL_MAX_SEQUENTIAL_DIRTY 3	/* max drty rgns in seq mode */

/*
 * protocol version numbers of vold/kernel interface
 */
#define VOL_KERNEL_VERSION_1_2	4	/* VxVM 1.2 kernel version */
#define VOL_KERNEL_VERSION_2_0	5	/* VxVM 2.0 kernel version */
#define VOL_KERNEL_VERSION_2_2	6	/* VxVM 2.2 kernel version */
#define VOL_KERNEL_VERSION_2_3	7	/* VxVM 2.3 kernel version */
#define VOL_KERNEL_VERSION	VOL_KERNEL_VERSION_2_3

#endif	/* _VXVM_VOLDEFAULT_H */
