/* @(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/voldioctl.h /main/uw7_nj/2 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/voldioctl.h /main/uw7_nj/2"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLDIOCTL_H
#define _VXVM_VOLDIOCTL_H

/*
 * voldioctl.h - vold/kernel interface structures and ioctls
 */

#ifdef	_KERNEL_HEADERS
#include <vxio.h>
#else
#include <vxvm/vxio.h>
#endif

/*
 * ioctl codes for the volconfig device interface
 */

#define VOL_RESET_KERNEL	VOL_IOCTL_CODE(111)

#define VOL_GET_KMEM		VOL_IOCTL_CODE(112)
#define VOL_SET_KMEM		VOL_IOCTL_CODE(113)

#define VOL_KTRANS		VOL_IOCTL_CODE(114)
#define VOL_KTRANS_ABORT	VOL_IOCTL_CODE(115)
#define VOL_GET_KTRANS_STATE	VOL_IOCTL_CODE(117)

#define VOL_NEW_GROUP		VOL_IOCTL_CODE(118)
#define VOL_CHANGE_GROUP	VOL_IOCTL_CODE(119)
#define VOL_DELETE_GROUP	VOL_IOCTL_CODE(120)
#define VOL_DUMP_GROUPS		VOL_IOCTL_CODE(121)
#define VOL_GET_GROUPS		VOL_IOCTL_CODE(122)

#define VOL_NEW_DISK		VOL_IOCTL_CODE(123)
#define VOL_CHANGE_DISK		VOL_IOCTL_CODE(124)
#define VOL_DELETE_DISK		VOL_IOCTL_CODE(125)
#define VOL_DUMP_DISKS		VOL_IOCTL_CODE(126)
#define VOL_GET_DISKS		VOL_IOCTL_CODE(127)

#define VOL_GET_OBJECT		VOL_IOCTL_CODE(128)
#define VOL_DUMP_OBJECTS	VOL_IOCTL_CODE(129)
#define VOL_GET_DEV		VOL_IOCTL_CODE(130)
#define VOL_DUMP_DEV		VOL_IOCTL_CODE(131)
#define VOL_GET_OBJECT_LOCKED	VOL_IOCTL_CODE(132)
#define VOL_DUMP_OBJECTS_LOCKED	VOL_IOCTL_CODE(133)

#define VOL_KTRANS_COMMIT	VOL_IOCTL_CODE(134)
#define VOL_KTRANS_LOCK		VOL_IOCTL_CODE(135)
#define VOL_KTRANS_LOCK_DEV	VOL_IOCTL_CODE(136)
#define VOL_KTRANS_SET_DEV	VOL_IOCTL_CODE(137)
#define VOL_KTRANS_SET_OBJECT	VOL_IOCTL_CODE(138)
#define VOL_KTRANS_DELETE_OBJECT VOL_IOCTL_CODE(139)

/*
 * Kernel Logging ioctls. Used to initialize logging areas and sizes. Also
 * used to query logging errors etc.
 */
#define	VOL_KLOG_SETDGLOGSZ	VOL_IOCTL_CODE(150)	/* Set disk group's log size */
#define VOL_KLOG_GETDGLOGSZ	VOL_IOCTL_CODE(151)	/* Get disk group's log size */
#define	VOL_KLOG_SETLOG		VOL_IOCTL_CODE(152)	/* Upload logging areas */
#define	VOL_KLOG_GETLOG		VOL_IOCTL_CODE(153)	/* Dump out logging areas */
#define	VOL_KLOG_FREELOG	VOL_IOCTL_CODE(154)	/* Free logging areas */
#define	VOL_KLOG_DGERRLIST	VOL_IOCTL_CODE(155)	/* Return disk group logging
							errors */
#define	VOL_KLOG_ERRLIST	VOL_IOCTL_CODE(156)	/* Return disk logging errors */
#define VOL_KLOG_DUMPENT	VOL_IOCTL_CODE(157)	/* Dump out active logents */

/*
 * ioclts for voldio.
 * NOTE: VOL_VOLD_IOCTL and VOL_VOLD_SDI_INFO are preserved for compatibility
 *	 with beta releases of VxVM 1.2.
 */
#define VOL_VOLDIO_READ		VOL_IOCTL_CODE(160)	/* read ioctl */
#define VOL_VOLDIO_WRITE	VOL_IOCTL_CODE(161)	/* write ioctl */

/*
 * Kernel licensing information ioctls
 */
#define VOL_SET_KLICENSE	VOL_IOCTL_CODE(170)
#define VOL_GET_KLICENSE	VOL_IOCTL_CODE(171)

/*
 * These ioctls are only available for debugging
 */

#define VOL_SET_ROOTDEV		VOL_IOCTL_CODE(181)
#define VOL_SET_SWAPDEV		VOL_IOCTL_CODE(182)
#define VOL_SET_BOOTARGS	VOL_IOCTL_CODE(186)
#define VOL_CLEAR_BOOTARGS	VOL_IOCTL_CODE(187)
#define	VOL_CLEAR_ROOTFLAG	VOL_IOCTL_CODE(188)
#define	VOL_CLEAR_SWAPFLAG	VOL_IOCTL_CODE(189)

#ifdef SOLARIS
/*
 * VOL_GET_TOP_DEVINFO - Solaris ioctl to get top of kernel devinfo tree
 */
#define VOL_GET_TOP_DEVINFO	VOL_IOCTL_CODE(190)
#endif /* SOLARIS */

/*
 * volktrans - describe a transaction to the kernel
 *
 * ioctls: VOL_KTRANS
 *
 * This structure describes a transaction to the kernel, specifying
 * the disk group of the transaction, and the configuration tid to use
 * when the transaction commits.
 */

struct volktrans {
	volrid_t	 kt_dg_iid;		/* 0x00 diskgroup import ID */
	volseqno_t	 kt_pending_tid;	/* 0x08 pending trans ID */
};						/* 0x10 */

/*
 * volktranstate - report the current transaction state from the kernel
 *
 * ioctls: VOL_GET_KTRANS_STATE
 *
 * This structure is returned by the kernel to indicate the current
 * state of the kernel transaction engine.  If the state is COMMITTED,
 * or ABORTED, then no transaction is in progress, although the
 * volktrans structure does still identify the transaction that was
 * committed or aborted.  If the state is ABORTED, the kts_abort_err
 * field identifies the reason for the abort.
 */

struct volktranstate {
	struct volktrans	kts_trans;	/* 0x00 current trans */
	volseqno_t		kts_config_tid;	/* 0x10 last commited tid */
	int			kts_state;	/* 0x18 state */
	int			kts_abort_err;	/* 0x1c reason for abort */
	volrid_t		kts_abort_rid;	/* 0x20 unused, from 1.2 */
};						/* 0x28 */

/* values for volktranstate.kts_state */
#define VOL_KTRANS_COMMITTED	1	/* last transaction committed */
#define VOL_KTRANS_ABORTED	2	/* last transaction aborted */
#define VOL_KTRANS_PENDING	3	/* transaction is in progress */

/* values for volktranstate.kts_abort_err */
#define VKE_NOTRANS     0       /* no pending transaction */
#define VKE_INVAL	1	/* invalid parameter in configuration */
#define VKE_ASSERT	2	/* assertion failed during commit */
#define VKE_REQUEST	3	/* abort requested via ioctl */
#define VKE_KLOGFAIL	4	/* klog of transaction commit failed */
#define VKE_IOFAIL	5	/* I/O or open failure */

/*
 * volkdev - describe a volume device entry
 *
 * ioctls: VOL_GET_DEV, VOL_KTRANS_SET_DEV
 *
 * The volume device entry only names an object.  Any interesting
 * state must be in the object itself.  When changing a volkdev
 * structure within a transaction, the kdev_dg_iid field is
 * ignored, since the disk group is already identified by the
 * transaction.
 *
 * To delete an object from the volume device table, clear kdev_rid.
 */

struct volkdev {
	volrid_t	 kdev_rid;		/* 0x00 object for entry */
	volrid_t	 kdev_dg_iid;		/* 0x08 disk group ID */
	voldevno_t	 kdev_dev;		/* 0x10 dev number of entry */
	volflag_t	 kdev_flags;		/* 0x14 flags for entry */
	ushort_t	 kdev_maxiosize;	/* 0x18 max I/O size (blks) */
	/*
	 * the following values are used in returning values for
	 * various query ioctls
	 */
	ushort_t	 kdev_ncylinder;	/* 0x1a #cyls to report */
	ushort_t	 kdev_ntrack;		/* 0x1c tracks/cyl to report */
	ushort_t	 kdev_nsector;		/* 0x1e sects/track to report*/
#ifdef SOLARIS
	ushort_t	 kdev_interleave;	/* 0x20 interleave to report */
	ushort_t	 kdev_rpm;		/* 0x22 rpm to report */
	ushort_t	 kdev_write_reinstruct;	/* 0x24 ??? to report */
	ushort_t	 kdev_read_reinstruct;	/* 0x26 ??? to report */
#endif /* SOLARIS */
	struct vx_ioparameters	kdev_ioparms;	/* 0x28 sizes wanted by vol */
};						/* 0x78 */

/* flag values for volkdev.kdev_flags */
#define VOLKDEV_FLAG_OPEN	0x00000001	/* device is open */
#define VOLKDEV_FLAG_PRESERVE	0x00000002	/* keep after RESET_KERNEL */

/*
 * volkdev_dump - structure to fetch all volume device slots from the kernel
 *
 * ioctls: VOL_DUMP_DEV
 *
 * Vold can get the count of volume device entries by using a kdevd_cnt
 * of zero.  The VOL_DUMP_VOLTAB ioctl will then fill in kdevd_cnt with
 * the number of defined volume device slots.
 */

struct volkdev_dump {
	size_t		 kdevd_cnt;		/* 0x00 count of volkdev's */
	struct volkdev	*kdevd_ptr;		/* 0x04 dev info buffer */
};						/* 0x08 */

/*
 * volkdev_assert_buf - assert the state of volume device slots
 *
 * ioctls: VOL_KTRANS_LOCK_DEV
 *
 * Specify a buffer of asserts to apply to volume device slots.
 */

struct volkdev_assert {
	voldevno_t	 kda_dev;		/* 0x00 device for assert */
	volflag_t	 kda_flags;		/* 0x04 flags to assert */
};						/* 0x08 */

/* flag values for volkdev_assert.kda_flags */
#define VOLDEV_FLAG_ASSERTOPEN	0x00000001	/* assert device open */
#define VOLDEV_FLAG_ASSERTCLOSE	0x00000002	/* assert device close */
#define VOLDEV_FLAG_ASSERTMASK	0x00000003	/* mask device asserts */

struct volkdev_assert_buf {
	size_t		 kdab_ndev;		/* 0x00 number of devices */
	struct volkdev_assert *kdab_devs;	/* 0x04 device assertions */
};						/* 0x08 */

/*
 * volklock_buf, volklock - describe transaction locks to the kernel
 *
 * ioctls: VOL_KTRANS_LOCK
 *
 * Transaction locks are loaded into the kernel in large buffers, to
 * minimize the number of ioctls needed for a transaction that
 * involves a large number of objects.  Each lock is described by a
 * record ID (within the context of the transaction disk group), and
 * an optional buffer of assert information.  The assert information
 * is object-type-specific information that is used to ensure
 * agreement between vold and the kernel for information that can
 * change.
 *
 * Objects are not actually locked until the VOL_KTRANS_COMMIT is
 * issued to commit the transaction.  At that point, the assert
 * information is used to validate vold/kernel agreement on state.
 *
 * Lock buffers describe an indicated number of locks, each lock being
 * represented by a volklock structure.  Each volklock structure
 * defines an object rid, and a pointer and size of the assert
 * information within the klb_assert_buf element of the volklock_buf
 * structure.
 *
 * Multiple VOL_KTRANS_LOCK ioctls can be specified within a single
 * transaction to load in multiple sets of lock descriptions.
 */

struct volklock_buf {
	size_t		 klb_nlock;		/* 0x00 number of locks */
	size_t		 klb_assert_bufsize;	/* 0x04 size of assert_buf */
	struct volklock *klb_volklock;		/* 0x08 array of locks */
	VOID		*klb_assert_buf;	/* 0x0c buffer of asserts */
};						/* 0x10 */

struct volklock {
	volrid_t	 kl_rid;		/* 0x00 rid of object */
	volflag_t	 kl_parent_sflag;	/* 0x08 assert parent_sflag */
	size_t		 kl_assert_size;	/* 0x0c size of assert info */
	VOID		*kl_assert;		/* 0x10 assert pointer in buf */
};						/* 0x14 */

/*
 * generic kernel-define kl_parent_sflag values:
 */
#define VOL_PSFLAG_NOASSERT	0x00000001	/* no parent_sflag assertion */

/*
 * volkobject - interface structure for object descriptions
 *
 * ioctls: VOL_NEW_OBJECT, VOL_CHANGE_OBJECT, VOL_GET_OBJECT
 *
 * This structure is used in transactions to create or change kernel
 * configuration objects.  Each object is described by its object
 * type, a type-specific vold/kernel interface structure, an
 * association, and an association description buffer.  When changing
 * an existing object, the object must have been locked with
 * VOL_KTRANS_LOCK.
 *
 * When getting an object description from the kernel with
 * VOL_GET_OBJECT, ko_object, ko_name, and ko_asinfo point to the
 * memory to write the object, name, and assert information into.  If
 * the sizes are not known, ko_size can be set to zero, in which case
 * vold will fill in ko_size, ko_name_size, and ko_asinfo_size and
 * return the buffer otherwise unchanged.  If the name or association
 * information is not wanted, ko_name_size or ko_asinfo_size can be
 * zero even when ko_size is non-zero.
 *
 * Vold can store anything that it wants in the ko_vflag field, and
 * whatever is stored will be returned when the record is retrieved
 * from the kernel.
 */

struct volkobject {
	volrid_t	 ko_rid;		/* 0x00 object rid */
	volrid_t	 ko_dg_iid;		/* 0x08 disk group of object */
	volrid_t	 ko_assoc_rid;		/* 0x10 object for associate */
	int		 ko_type;		/* 0x18 object type */
	volflag_t	 ko_vflag;		/* 0x1c vold private flags */
	volflag_t	 ko_parent_sflag;	/* 0x20 assoc status flags */
	size_t		 ko_object_size;	/* 0x24 size of object */
	size_t		 ko_name_size;		/* 0x28 size of object name */
	size_t		 ko_asinfo_size;	/* 0x2c size of assoc info */
	VOID		*ko_object;		/* 0x30 object description */
	char		*ko_name;		/* 0x34 object name */
	VOID		*ko_assoc_info;		/* 0x38 association info */
};						/* 0x3c */

/* values for volkobject.ko_type */
#define VOLOBJ_TYPE_SUBDISK	1	/* subregion of a disk */
#define VOLOBJ_TYPE_SUBVOLUME	2	/* subregion of another object */
#define VOLOBJ_TYPE_PLEX	3	/* striped or concatenated plex */
#define VOLOBJ_TYPE_MIRRORVOL	4	/* mirrored object */
#define VOLOBJ_TYPE_RAID	5	/* RAID5 volume */

#define VOLOBJ_TYPE_DISK	0	/* pseudo-object, used in some ioctls */

/*
 * volkobject_dump - fetch groups of objects from the kernel
 *
 * ioctls: VOL_DUMP_OBJECTS
 *
 * This structure is used to fetch all volume manager configuration
 * objects in a disk group, or all objects of a particular type, from
 * the kernel.  kod_type matches the ko_type field of volkobject, or
 * it can be zero to request all objects.
 *
 * Since objects and association information are of variable sizes, a
 * buffer must be supplied by the user to store the objects and the
 * association information.  This buffer must be large enough to store
 * all object and association information.  To get the minimum buffer
 * size needed, call VOL_DUMP_OBJECTS with a zero for kod_nobject,
 * this will return the structure with kod_bufsize set to the needed
 * size and with kod_nobject set to the number of objects.
 */

struct volkobject_dump {
	volrid_t	 kod_dg_iid;		/* 0x00 disk group */
	int		 kod_type;		/* 0x08 type to fetch */
	size_t		 kod_nobject;		/* 0x0c number of objects */
	size_t		 kod_bufsize;		/* 0x10 size of buf */
	struct volkobject *kod_objects;		/* 0x14 object buffers */
	VOID		*kod_buf;		/* 0x18 buf of structures */
};						/* 0x1c */

/*
 * volkdg - interface structure for disk groups
 *
 * ioctls: VOL_NEW_GROUP, VOL_CHANGE_GROUP, VOL_DELETE_GROUP
 *
 * This structure defines a disk group to the kernel.  Disk groups
 * have three distinct identifiers: a disk group name, a disk group
 * unique ID, and an import ID.  Vold can store 
 */

struct volkdg {
	char		 kdg_uuid[VOL_UUID_SZ];	/* 0x00 diskgroupID */
	volrid_t	 kdg_iid;		/* 0x44 import ID */
	char		 kdg_name[NAME_SZ];	/* 0x4c local name */
	ulong_t		 kdg_kflag;		/* 0x6c perm flags */
	ulong_t		 kdg_vflag;		/* 0x70 vold-private flags */
	volseqno_t	 kdg_config_tid;	/* 0x74 last commit */
};						/* 0x7c */

/* flag values for volkdg.kdg_kflag */
#define DG_KFLAG_RDONLY		0x00000001	/* read only disk group */

/*
 * volkdg_dump - fetch disk group records from the kernel
 *
 * ioctls: VOL_DUMP_GROUPS, VOL_GET_GROUPS
 *
 * This structure is used to fetch all disk group records from the
 * kernel.  To determine how many disk group records are in the
 * kernel, set kdgd_cnt to zero.  The kernel will then set kdgd_cnt to
 * the number of disk groups and will leave the structure otherwise
 * unchanged.
 *
 * A specific set of disk groups can be fetched from the kernel using
 * the VOL_GET_GROUPS ioctl.  This uses kdgd_cnt and kdgd_ptr to point
 * to a set of volkdg structures that have kdg_iid filled in.
 * The disk groups are found in the kernel and replace the
 * corresponding volkdg structures.
 */

struct volkdg_dump {
	size_t		 kdgd_cnt;		/* 0x0 number of structs */
	struct volkdg	*kdgd_ptr;		/* 0x4 ptr to structs */
};						/* 0x8 */

/*
 * volkdisk - interface structure for disks
 *
 * ioctls: VOL_NEW_DISK, VOL_CHANGE_DISK, VOL_DELETE_DISK
 *
 * This structure defines a disk to the kernel.  Disks are in two
 * separate namespaces: a disk name space separate from disk groups
 * (the da_rid value), and a disk group name space (the dm_rid value).
 * Disks can be within or outside of a disk group, and can be moved
 * out of a disk group and into another one.  The current disk group
 * for a disk is identified by the kd_dg_iid field which
 * identifies the disk group by import ID.
 *
 * The device that the disk is defined on is defined by the pub_dev
 * and the priv_dev which define the public region partition device
 * and the private region partition device, respectively.  These may
 * be the same, or the priv_dev can be VOLNODEV.
 *
 * The kd_vflag field is available for any use by vold.  This field
 * can be loaded with any value, and that value will be returned when
 * the record is retrieved by vold.
 */

struct volkdisk {
	char		 kd_da_name[NAME_SZ];	/* 0x00 DA record name */
	char		 kd_dm_name[NAME_SZ];	/* 0x0f admin. name */
	volrid_t	 kd_da_rid;		/* 0x20 da record rid */
	volrid_t	 kd_dg_iid;		/* 0x28 disk group */
	volrid_t	 kd_dm_rid;		/* 0x30 dm record rid **/
	ulong_t		 kd_kflag;		/* 0x38 control flag */
	ulong_t		 kd_sflag;		/* 0x3c status flag */
	ulong_t		 kd_vflag;		/* 0x40 vold flag */
	voldevno_t	 kd_pub_dev;		/* 0x44 public partition */
	voldevno_t	 kd_priv_dev;		/* 0x48 private partition */
	voff_t		 kd_pub_len;		/* 0x4c public length */
	voff_t		 kd_priv_len;		/* 0x50 private length */
	size_t		 kd_maxiosize;		/* 0x54 max I/O size (blks) */
	char		 kd_type[DA_TYPE_SZ];	/* 0x58 disk type */
	char		 kd_info[DA_INFO_SZ];	/* 0x67 type-specific info */
};						/* 0xe8 */

/* flag values for volkdisk.kd_sflag */
#define D_SFLAG_SDOPEN		0x00000001	/* subdisk on disk is open */

/* flag values for volkdisk.kd_kflag */
#define D_KFLAG_PRESERVE	0x00000001	/* keep across RESET_KERNEL */

/*
 * volkdisk_dump - fetch disk records from the kernel
 *
 * ioctls: VOL_DUMP_DISKS, VOL_GET_DISKS
 *
 * This structure is used to fetch all disk records from the kernel.
 * To determine how many disk records are in the kernel, set kdd_cnt
 * to zero.  The kernel will then set kdd_cnt to the number of disks
 * and will leave the structure otherwise unchanged.
 *
 * Disks can be fetched only from a specific disk group by setting
 * kdd_dg_iid.
 *
 * A specific set of disks can be fetched from the kernel using the
 * VOL_GET_DISKS ioctl.  This uses kdd_cnt and kdd_ptr to point to a
 * set of volkdisk structures that have kd_da_rid filled in.  The
 * disks are found in the kernel and replace the corresponding
 * volkdisk structures.
 */

struct volkdisk_dump {
	volrid_t	 kdd_dg_iid;		/* 0x00 disk group */
	size_t		 kdd_cnt;		/* 0x08 number of structs */
	struct volkdisk	*kdd_ptr;		/* 0x0c pointer to structs */
};						/* 0x10 */

/*
 * volprivmem - define private memory stored and retrieved by vold
 *
 * ioctls: VOL_GET_KMEM, VOL_SET_KMEM
 *
 * This structure defines regions of kernel memory that vold can use
 * for any purpose.  Each region is defined by an ID, which should be
 * a small integer.  To create or replace a region with a specified
 * ID, vold should set pm_size to new size of the region, and pm_ptr
 * to point to the region contents.
 *
 * Vold can determine the size of an identified kernel memory by
 * setting pm_id to the region ID and pm_size to zero and calling
 * VOL_GET_KMEM.  This will set pm_size to the identified region's
 * size and will leave the structure otherwise unchanged.
 */

struct volprivmem {
	ulong_t		 pm_id;			/* 0x00 mem ID */
	size_t		 pm_size;		/* 0x04 bytes */
	VOID		*pm_ptr;		/* 0x08 contents */
};						/* 0x0c */

/*
 * Limits for ioctl's that allocate kernel memory
 */

#define VOL_MAX_GETSTRUCT	1024		/* !!! should be tunable */

/*
 * Number of vold/kernel private memory areas
 */

#define VOL_PRIVMEM_MAX_ID	256		/* !!! should be a tunable */
#define	VOL_PRIVMEM_CHUNK	16		/* granularity of allocation */
#define VOL_PRIVMEM_MAX_KMEM	1024*1024	/* limit of 1M in buffers */

/*
 * The following structures define the structures passed as part of the ioctl
 * interface for the kernel logging functions.
 */

/*
 * This structure for the VOL_KLOG_DGLOGSZ ioctl call that will resize the
 * log for a disk group.
 */
struct volklog_dglogsz {
	volrid_t	dlz_dgrid;	/* 0x0 Disk group */
	long		dlz_size;	/* 0x8 New log length */
};					/* 0xc */

/* 
 * The following structure contains a description of a logging area on
 * disk. The area is defined by the device and offset on the disk device.
 * The log offset represented by this area is dependant on the logging
 * area's position in the table of logareas pointed to by the disk
 * structure.
 */
struct volklogarea {
	int	lr_flags;	/* 0x0 flags controlling the log area */
	int	lr_error;	/* 0x4 dev returned an error and is disabled */
	voff_t	lr_off;		/* 0x8 offset into logging device */
};				/* 0xc */

/*
 * Flags for lr_flags.
 */
#define VOL_LR_PRIVREGION	0x1	/* dev for log area is private region */
#define VOL_LR_PUBREGION	0x2	/* dev for log area is public region */

/*
 * This structure is for the VOL_KLOG_SETLOG ioctl that sets up a specified
 * log copy for a specified disk.
 */
struct volklog_setlog {
	volrid_t		sl_drid;	/* 0x00 disk in group */
	long			sl_logcpy;	/* 0x08 which log copy */
	struct volklogarea	*sl_logareap;	/* 0x0c table of log areas */
	int			sl_nlogarea;	/* 0x10 # of log areas */
};						/* 0x14 */

/*
 * This structure is used for the VOL_KLOG_DGERRLIST, VOL_KLOG_ERRLIST, and
 * VOL_KLOG_DUMPENT ioctl calls. It defines the disk group and optionally
 * the disk to restrict the search for the data to. It also defines the user
 * address where the returned data is to be stored, and the number of structures
 * of the appropriate type that the memory has space to hold.
 */
struct volklog_getlist {
	volrid_t	gl_dgrid;	/* 0x00 disk group */
	volrid_t	gl_disk;	/* 0x08 disk */
	caddr_t		gl_addr;	/* 0x10 user address for copyout */
	long		gl_size;	/* 0x14 number of structs to copy */
};					/* 0x18 */

/*
 * The following identifies a failing log for a specific disk group.
 */
struct voldg_errlist {
	volrid_t	vdg_disk;	/* 0x0 disk with a failed log copy */
	int		vdg_copy;	/* 0x8 copy number of log in disk */
};					/* 0xc */

/*
 * The following identifies a failing log block on a specific disk.
 * This structure is generated solely for the interface to vold. 
 */
struct voldisk_errlist {
	int	vd_copy;	/* 0x0 copy number of failed log in disk */
	int	vd_blkoff;	/* 0x4 block offset of failure in log */
};				/* 0x8 */

/*
 * Structure defining a disk region to perform I/O to.
 */
struct voldio_region {
	ulong_t		vdior_flags;	/* 0x00 flags */
	int		vdior_errno;	/* 0x04 errno for failed ops */
	volrid_t	vdior_drid;	/* 0x08 disk rid */
	voff_t		vdior_offset;	/* 0x10 offset on device */
};					/* 0x14 */

#define VOL_VOLDIO_REG_PUB	0x1
#define VOL_VOLDIO_REG_PRIV	0x2

/*
 * Structure used by vold to request parallel I/O operations from the kernel.
 */
struct voldio {
	ulong_t			vdio_flags;	/* 0x00 flags */
	caddr_t			vdio_buf;	/* 0x04 ptr to I/O buffer */
	size_t			vdio_len;	/* 0x08 length of buffer */
	size_t			vdio_nregion;	/* 0x0c # of region structs */
	struct voldio_region	vdio_regions[1];/* 0x10 I/O regions */
};						/* 0x24 */

/*
 * Kernel licensing flags
 */
#define	VOL_KLIC_BASIC		0x00000001	/* Basic */
#define VOL_KLIC_CONCAT		0x00000002	/* Concat */
#define VOL_KLIC_SPAN		0x00000004	/* Span */
#define VOL_KLIC_MIRROR		0x00000008	/* Mirror */
#define VOL_KLIC_STRIPE		0x00000010	/* Stripe */
#define VOL_KLIC_RAID5		0x00000020	/* Raid */
#define VOL_KLIC_SSA		0x00000040	/* SSA */
#define VOL_KLIC_ORM		0x00000080	/* Oracle Recovery */

#endif	/* _VXVM_VOLDIOCTL_H */
