/* @(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/volioctl.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/volioctl.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLIOCTL_H
#define _VXVM_VOLIOCTL_H

/*
 * volioctl - volume manager device ioctls
 *
 * NOTE: This does not contain special vold/kernel interface ioctls.
 */

/*
 * ioctl commands for any volume manager device
 */

#define	GET_DAEMON		(VOLIOC | 1)
#define	GET_VOLINFO		(VOLIOC | 2)

/*
 * ioctls for /dev/rvol devices
 */

#define	ATOMIC_COPY		(VOLIOC | 50)
#define	PLEX_READ		(VOLIOC | 51)
#define	PLEX_WRITE		(VOLIOC | 52)
#define	PLEX_DEV_READ		(VOLIOC | 53)
#define	PLEX_DEV_WRITE		(VOLIOC | 54)
#define	VERIFY_READ		(VOLIOC | 55)
#define	VERIFY_WRITE		(VOLIOC | 56)
#define VOL_LOG_WRITE		(VOLIOC | 58)
#define	PLEX_DETACH		(VOLIOC | 59)
#define VOL_READ		(VOLIOC | 60)
#define VOL_WRITE		(VOLIOC | 61)
#define VOL_R5_ZERO		(VOLIOC | 62)
#define VOL_R5_RECOVER		(VOLIOC | 63)
#define VOL_R5_RESYNC		(VOLIOC | 64)
#define VOL_R5_LOGFLUSH		(VOLIOC | 65)
#define VOL_R5_VERIFY		(VOLIOC | 66)

/*
 * ioctls for /dev/volevent device
 */

#define	VOLIOT_ERROR_TRACE_INIT	(VOLIOC | 68)
#define	VOLIOT_IO_TRACE_INIT	(VOLIOC | 69)
#define	VOLIOT_DISCARD		(VOLIOC | 70)
#define	VOLIOT_IO_TRACE		(VOLIOC | 71)
#define	VOLIOT_IO_UNTRACE	(VOLIOC | 72)

/*
 * ioctl for /dev/volinfo device
 */

#define VOL_GET_DAEMON_PID	(VOLIOC | 74)
#define VOL_GET_IO_STATS	(VOLIOC | 75)
#define VOL_CLEAR_IO_STATS	(VOLIOC | 76)
#define VOL_INDIRECT_IOCTL	(VOLIOC | 77)
#define VOL_GET_DISKDRIVER_INFO	(VOLIOC | 78)
#define VOL_SET_VOLINFO		(VOLIOC | 79)	/* only in debugging kernel */

/*
 * ioctls for /dev/voliod device
 *
 * NOTE: the LOGIOD ioctls are needed to interface with a VxVM 1.2
 *	 kernel, but are unused with VxVM 2.0.
 */

#define	VOL_IO_DAEMON		(VOLIOC | 80)
#define VOL_IO_DAEMON_SET	(VOLIOC | 81)
#define	VOL_IO_DAEMON_CNT	(VOLIOC | 82)
#define VOL_LOG_IO_DAEMON	(VOLIOC | 83)	/* VxVM 1.2 compatibility */
#define	VOL_LOGIOD_WAIT		(VOLIOC | 84)	/* VxVM 1.2 compatibility */
#define	VOL_LOGIOD_KILL		(VOLIOC | 85)	/* VxVM 1.2 compatibility */
#define	VOL_LOGIOD_CHECK	(VOLIOC | 86)	/* VxVM 1.2 compatibility */
#define VOL_OBJECT_IOCTL	(VOLIOC | 87)

/*
 * ioctls for use by file systems
 *
 * NOTE: These ioctls are actually intended to be implemented by file
 *	 systems.  VxFS provides these ioctls on the root directory of
 *	 a VxFS file system.
 */

#define VOL_FREEZE		(VOLIOC | 100)	/* stop file system activity */
#define VOL_THAW		(VOLIOC | 101)	/* restart file system */

/*
 * volinfo - kernel information structure
 *
 * ioctls: GET_VOLINFO
 *
 * This structure defines kernel tunables and other values that are
 * defined when a kernel is built.
 */

struct volinfo {
	long	version;		/* 0x00 kernel version number */
	long	max_volprivmem;		/* 0x04 max size of volprivmem area */
	major_t	volbmajor;		/* 0x08 volume blk dev major number */
	major_t	volcmajor;		/* 0x0c volume char dev major number */
	major_t	plexmajor;		/* 0x10 plex device major number */
	long	maxvol;			/* 0x14 max # of volumes supported */
	long	maxplex;		/* 0x18 max # of associated plexes */
	long	plexnum;		/* 0x1c max plexes per volume */
	long	sdnum;			/* 0x20 max subdisks per plex */
	long	max_ioctl;		/* 0x24 max size of ioctl data */
	long	max_specio;		/* 0x28 max size of ioctl I/O op */
	long	max_io;			/* 0x2c max size of I/O operation */
	long	vol_maxkiocount;	/* 0x30 max # top level I/Os allowed */
	long	dflt_iodelay;		/* 0x34 default I/O delay for utils */
	long	voldrl_min_regionsz;	/* 0x38 min DRL region size */
	long	voldrl_max_drtregs;	/* 0x3c max # of DRL dirty regions */
	long	max_parallelio;		/* 0x40 max # voldios allowed */
#ifdef SOLARIS
	long	vol_is_root;		/* 0x44 indicates that root is a vol */
	long    mvrmaxround;		/* 0x48 max round-robin region size */
	long    prom_version;		/* 0x4c PROM version of the system */
#else
        long    vol_unused_1;           /* 0x44 unused */
        long    mvrmaxround;            /* 0x48 max round-robin region size */
        long    vol_unused_3;           /* 0x4c unused */
#endif /* SOLARIS */
	long	vol_maxstablebufsize;	/* 0x50 max size of copy buffer */
	size_t	voliot_iobuf_limit;	/* 0x54 max total I/O trace buf spc */
	size_t	voliot_iobuf_max;	/* 0x58 max size of I/O trace buffer */
	size_t	voliot_iobuf_default;	/* 0x5c default I/O trace buf size */
	size_t	voliot_errbuf_default;	/* 0x60 default error trace buf sz */
	long	voliot_max_open;	/* 0x64 max # of trace channels */
	size_t	vol_checkpt_default;	/* 0x68 default checkpoint size */
	long	volraid_rsrtransmax;	/* 0x6c max # of transient RSRs */
	long    volinfo_spare[4];	/* 0x78 unused - reserved for later */
};					/* 0x80 */

/*
 * vol_object_ioctl - send an ioctl to an arbitrary VxVM kernel object
 *
 * ioctls: VOL_OBJECT_IOCTL
 *
 * This ioctl can be issued against the /dev/voliod device to issue an
 * ioctl against any volume manager kernel configuration object.  This
 * is needed for objects that do not have a corresponding volume
 * device number (i.e., recursive volumes that do not have a device
 * node).
 */

struct vol_object_ioctl {
	volrid_t    ioc_rid;		/* 0x00 rid of kernel object */
	volrid_t    ioc_dg_iid;		/* 0x08 disk group of kernel object */
	int	    ioc_cmd;		/* 0x10 command to issue */
	void	    *ioc_arg;		/* 0x14 argument to command */
};					/* 0x18 */

/*
 * vol_io - specify a special mirrored volume I/O
 *
 * ioctls: ATOMIC_COPY, VERIFY_READ, VERIFY_WRITE, PLEX_READ, PLEX_WRITE
 *
 * Specify a set of source and destination plexes for an I/O, along
 * with the size of the I/O and a pointer to a user-space buffer for
 * the I/O.
 */

/*
 * Backward compatability field names.
 */
#define	vi_nsrcplex	vi_nsrcmir
#define	vi_ndestplex	vi_ndestmir
#define	vi_plexptr	vi_mirptr

struct plx_ent {
	char	mo_name[NAME_SZ];
	int	mo_errno;
};

typedef struct plx_ent	mirror_ent;

/*
 * Backward compatability
 */
#define	pe_name		mo_name
#define	pe_errno	mo_errno

struct vol_io {
	voff_t		vi_offset;	/* 0x00 offset on plex */
	size_t		vi_len;		/* 0x04 amount of data to read/write */
	caddr_t		vi_buf;		/* 0x08 ptr to buffer */
	size_t		vi_nsrcmir;	/* 0x0c number of source plexes */
	size_t		vi_ndestmir;	/* 0x10 number of destination plexes */
	mirror_ent	*vi_mirptr;	/* 0x14 ptr to array of plex entries */
	ulong_t		vi_flag;	/* 0x18 flags associated with op */
};					/* 0x1c */


/* flag values stored in vol_io.vi_flag */
#define	VI_LOGIO	0x00000001	/* perform operation to log area */

/*
 * vol_rdwr - read or write to a volume
 *
 * ioctls: VOL_READ, VOL_WRITE
 *
 * These ioctls specify volume read or write operations that are not
 * bounded by the off_t type.  Volumes can be larger than the maximum
 * file offset supported by the read() and write() system calls.
 * These ioctls are needed for any utility that needs to be able to do
 * I/O to any volume up to the limit of the volume size.
 */

struct vol_rdwr {
	volflag_t	vrw_flags;	/* 0x00 flags */
	voff_t		vrw_off;	/* 0x04 offset in volume (sectors) */
	size_t		vrw_size;	/* 0x08 number of sectors to Xfer */
	void		*vrw_addr;	/* 0x0c user address for Xfer */
};

/*
 * vol_indirect_ioctl - specify an ioctl to issue to an arbitrary device
 *
 * ioctls: VOL_INDIRECT_IOCTL
 *
 * This structure is used to request an ioctl to another device.
 * Utilities can use this to ioctl devices that don't have device
 * nodes, or where the device nodes can't be trusted to be correct.
 */

struct vol_indirect_ioctl {
	voldevno_t	vioc_dev;	/* 0x00 raw device number */
	int		vioc_cmd; 	/* 0x04 ioctl to issue */
	caddr_t		vioc_arg; 	/* 0x08 ioctl argument */
};					/* 0x0c */

/*
 * vol_diskdriver_info - disk driver information
 *
 * ioctls: VOL_GET_DISKDRIVER_INFO
 *
 * This structure can be used to get information about the disk device
 * drivers attached to this machine.  This structure returns
 * information only for standard system disk drivers.  All drivers
 * returned must use the same number of partition devices per disk,
 * and must use the same maximum of disks for each major number.
 *
 * NOTE: Not all systems can support this ioctl.  Such systems should
 *	 just return 0 for the number of major numbers.  However,
 *	 npart should still be set to indicate the partitioning
 *	 standard for this system.
 */

struct vol_diskdriver_info {
	size_t	ddi_ndiskpermajor;	/* 0x00 # of disks per major */
	size_t	ddi_npart;		/* 0x04 # of partitions per disk */
	size_t	ddi_nmajor;		/* 0x08 # of major devices */
	major_t	*ddi_cmajors;		/* 0x0c char majors for sd01 */
	major_t	*ddi_bmajors;		/* 0x10 block majors for sd01 */
};					/* 0x14 */

/*
 * volarrayregion - disk array ioctl control structure
 *
 * ioctls: VOL_R5_ZERO, VOL_R5_RECOVER, VOL_R5_RESYNC
 *
 * This structure used to communicate the bounds of the array and, in some
 * cases specific column information to be used in performing recovery and
 * initialization operations.
 */

struct volarrayregion {
	int	var_flags;		/* 0x00 flags */
	int	var_colnum;		/* 0x04 column # for recovery */
	voff_t	var_coloff;		/* 0x08 offset in column */
	size_t	var_collen;		/* 0x0c length of recovery in column */
	int	var_colmaxio;		/* 0x10 max. col size of I/O to issue */
};
#define	VOL_VAR_INTR		0x0001	/* interruptable */

#endif	/* _VXVM_VOLIOCTL_H */
