/* @(#)unixsrc:usr/src/common/uts/io/vxvm/common/voliomem.h /main/uw7_nj/1 %G% %U% - %Q% */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/common/voliomem.h /main/uw7_nj/1"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLIOMEM_H
#define _VXVM_VOLIOMEM_H

/*
 * voliomem.h - interface structures for pre-allocated memory management
 */

/*
 * voliomemlist - list of memory segments returned by voliomem_grab()
 *
 * This structure should be considered opaque by any routines outside
 * of iomem.c.  I/O memory iterators should be used, where needed, to
 * gain access to the memory in these lists.  All fields in this
 * structure are subject to change as a result of porting to different
 * operating systems.
 */
struct voliomemlist {
	struct voliomemseg	*ml_seglist;	/* 0x00 list of segments */
	voliomempage_t		*ml_pagelist;	/* 0x04 list of memory pages */
#ifdef VOLMEM_DEBUG
	struct voliomemlist	*ml_nextlist;	/* 0x08 debug list of lists */
	struct voliomemlist	*ml_prevlist;	/* 0x0c debug list of lists */
#endif	/* VOLMEM_DEBUG */
};						/* 0x08/0x10 */
/*
 * voliomemseg - definition for a contiguous memory segment
 */
struct voliomemseg {
	/* private fields: (used only in iomem.c) */
	struct voliomemseg	*ms_next;	/* 0x00 next segment */
	caddr_t			ms_addr;	/* 0x04 pointer to segment */
	size_t			ms_size;	/* 0x08 size of segment */
};						/* 0x0c */

/*
 * voliomemiter - I/O memory list iteration structure
 *
 * This structure is used for interfacing with functions that iterate
 * over an I/O memory list.  The mi_addr and mi_size fields can be
 * used by the caller of the iterator functions; the other fields
 * should be considered opaque and can be referenced only by the
 * iterator functions in iomem.c.
 */
struct voliomemiter {
	/* public fields: */
	caddr_t			mi_addr;	/* 0x00 pointer to segment */
	size_t			mi_size;	/* 0x04 size of segment */
	/* private fields: (used only in iomem.c) */
	size_t			mi_remain;	/* 0x08 remaining bytes */
	struct voliomemseg	*mi_nextseg;	/* 0x0c next seg to return */
	struct voliomemlist	*mi_memlist;	/* 0x10 original memlist */
};						/* 0x14 */

#endif	/* _VXVM_VOLIOMEM_H */
