/* @(#)uts.vxvm:vxvm/unixware/vollocal.h	1.1 1/24/97 21:58:27 - uts.vxvm:vxvm/unixware/vollocal.h */
#ident	"@(#)unixsrc:usr/src/common/uts/io/vxvm/unixware/vollocal.h /main/uw7_nj/3"

/*
 * Copyright(C)1996 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 * 
 *               RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 *               VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef _VXVM_VOLLOCAL_H
#define _VXVM_VOLLOCAL_H

/*
 * sys/vollocal.h - volume manager localization macros
 */

#if defined(UNIPROC)
#undef MP
#endif

#ifdef SOLARIS
typedef int	biodone_ret_t;
typedef int	ioctl_arg_t;

#define bdevcnt	devcnt
#define	cdevcnt	devcnt
#endif /* SOLARIS */

#ifdef UW_2_1
typedef void    biodone_ret_t;
typedef int     ioctl_arg_t;
#endif /* UW_2_1 */

#define VOLOTYP_LYR   OTYP_LYR

typedef biodone_ret_t (* buf_iodone_t)();

#define VOL_PUB_SLICE_TAG	0xe
#define VOL_PRIV_SLICE_TAG	0xf

#ifdef _KERNEL

/*
 * system-dependent feature enables
 */

/*
 * The following macros are for the kernel memory allocation routines used
 * by the Volume Manager.  They are switchable between DDI versions and
 * TED debugging versions.
 */
#define	_VOLMEMALLOC(sz, flag)	kmem_alloc((sz), (flag))
#define	_VOLMEMZALLOC(sz, flag)	kmem_zalloc((sz), (flag))
#define	_VOLMEMFREE(ptr, sz)	kmem_free((ptr), (sz))

#define VOLMEM_SLEEP		KM_SLEEP
#define VOLMEM_NOSLEEP		KM_NOSLEEP

#if	defined(VOLMEM_DEBUG)

#define	volmemalloc(sz, flag)	Xvolmemalloc(__LINE__, __FILE__, (sz), (flag))
#define	volmemzalloc(sz, flag)	Xvolmemzalloc(__LINE__, __FILE__, (sz), (flag))
#define	volmemfree(ptr, sz)	Xvolmemfree(__LINE__, __FILE__, (ptr), (sz))

extern void   *Xvolmemalloc(ulong, char *, size_t, int);
extern void   *Xvolmemzalloc(ulong, char *, size_t, int);
extern void    Xvolmemfree(ulong, char *, void *, size_t);

#else /* not VOLMEM_DEBUG */

#define	volmemalloc(sz, flag)		_VOLMEMALLOC((sz), (flag))
#define	volmemzalloc(sz, flag)		_VOLMEMZALLOC((sz), (flag))
#define	volmemfree(ptr, sz)		_VOLMEMFREE((ptr), (sz))

#endif /* VOLMEM_DEBUG */

#define volmemalloc_sleep(sz)		volmemalloc((sz), VOLMEM_SLEEP)
#define volmemzalloc_sleep(sz)		volmemzalloc((sz), VOLMEM_SLEEP)
#define volmemalloc_nosleep(sz)		volmemalloc((sz), VOLMEM_NOSLEEP)
#define volmemzalloc_nosleep(sz)	volmemzalloc((sz), VOLMEM_NOSLEEP)

/*
 * Following macros are for calls out to lower level driver bdevsw entries.
 */

#ifdef SOLARIS
#if defined(TED_ACTIVE)

#define VOL_DEV_STRATEGY(bp)						\
	do {								\
		TED_TRIG_IOSTRAT(bp);					\
		if ((bp)->b_flags & B_ERROR) {				\
			biodone(bp);					\
		} else {						\
			(bdev_strategy(bp));				\
		}							\
	} while (0)

#else	/* not TED_ACTIVE */

#define VOL_DEV_STRATEGY(bp)	(bdev_strategy(bp))

#endif	/* TED_ACTIVE */

#define VOL_DEV_OPEN(dev, cred_p)					\
	(dev_open(&(dev), V_OFLAGS, OTYP_LYR, (cred_p)))

#define	VOL_DEV_SAFE_OPEN(dev, cred_p)					\
	((*(devopsp[getmajor(dev)]->devo_cb_ops)->cb_open)(&(dev), 	\
							   V_OFLAGS,	\
							   OTYP_LYR,	\
							   (cred_p)))

#define VOL_CDEV_OPEN(dev, cred_p)	VOL_DEV_OPEN((dev), (cred_p))

#define VOL_DEV_CLOSE(dev, cred_p)					\
	(dev_close((dev), V_OFLAGS, OTYP_LYR, (cred_p)))

#define VOL_DEV_SAFE_CLOSE(dev, cred_p)					\
	((*(devopsp[getmajor(dev)]->devo_cb_ops)->cb_close)(&(dev),	\
							    V_OFLAGS,	\
							    OTYP_LYR,	\
							    (cred_p)))

#define VOL_CDEV_CLOSE(dev, cred_p)	VOL_DEV_CLOSE((dev), (cred_p))

#define VOL_CDEV_IOCTL(dev, cmd, arg, cred_p, rval_p)			\
	(cdev_ioctl((dev), (cmd), (ioctl_arg_t)(arg), V_OFLAGS, 	\
		    (cred_p), (rval_p)))

#define	VOL_DEV_SIZE_FN(dev)	(bdev_size)				\

#define	VOL_DEV_SIZE(dev)	(bdev_size((dev)))

#define VOL_DISK_DEV_OPEN(disk, region, cred_p)				\
		volsol_open_disk_device((disk), (region), (cred_p))

#define VOL_DISK_DEV_CLOSE(disk, region, cred_p)			\
		volsol_close_disk_device((disk), (region), (cred_p))

#else /* ! SOLARIS */

#ifdef NSC
#if	defined(TED_ACTIVE)

#define VOL_DEV_STRATEGY(bp)						\
		do {							\
			TED_TRIG_IOSTRAT(bp);				\
			if ((bp)->b_flags & B_ERROR) {			\
				biodone(bp);				\
			} else {					\
				rdev_strategy(bp);			\
			}						\
		} while (0)

#else /* !defined(TED_ACTIVE) */

#define VOL_DEV_STRATEGY(bp)						\
				rdev_strategy(bp);

#endif /* defined(TED_ACTIVE) */

#define VOL_DEV_OPEN(dev, cred_p, tag_p)				\
		rdev_open(&(dev), V_OFLAGS, OTYP_LYR,    		\
					(cred_p), tag_p, TRUE)

#define VOL_CDEV_OPEN(dev, cred_p)					\
		rdev_open(&(dev), V_OFLAGS, OTYP_LYR,    \
					(cred_p), NULL, FALSE)

#define VOL_DEV_CLOSE(dev, cred_p)					\
		rdev_close((dev), V_OFLAGS, OTYP_LYR,   		\
					(cred_p), TRUE)

#define VOL_CDEV_CLOSE(dev, cred_p)					\
		rdev_close((dev), V_OFLAGS, OTYP_LYR,   		\
					(cred_p), FALSE)

#define VOL_CDEV_IOCTL(dev, cmd, arg, cred_p, rval_p)		\
		rdev_ioctl((dev), (cmd), (arg),	\
					V_OFLAGS, (cred_p), (rval_p))

#define VOL_DEV_SIZE_FN(dev)						\
		rdev_size((dev))

#define VOL_DEV_SIZE(dev)						\
		rdev_size((dev))
#else  /* ! NSC */

#if     defined(TED_ACTIVE)
#define VOL_DEV_STRATEGY(bp)                                            \
                do {                                                    \
                        TED_TRIG_IOSTRAT(bp);                           \
                        if ((bp)->b_flags & B_ERROR) {                  \
                                biodone(bp);                            \
                        } else {                                        \
								do_strategy(bp);						\
                        }                                               \
                } while (0)
 
#else /* !defined(TED_ACTIVE) */
 
#define VOL_DEV_STRATEGY(bp)                                            \
				do_strategy(bp)
 
#endif /* defined(TED_ACTIVE) */
 

#define VOL_DEV_OPEN(dev, cred_p, tag_p)                                       \
				drv_devopen_vp(&dev,V_OFLAGS,VBLK,B_TRUE,cred_p,tag_p) 
 
#define VOL_DEV_CLOSE(dev, cred_p)                                      \
				drv_devclose(dev,V_OFLAGS,VBLK,cred_p)
 
#define VOL_CDEV_CLOSE(dev, cred_p)                                     \
				drv_devclose(dev,V_OFLAGS,VCHR,cred_p)

#define VOL_CDEV_IOCTL(dev, cmd, arg, cred_p, rval_p)           \
				drv_devioctl((dev), (cmd), (arg), V_OFLAGS, VCHR,\
					(cred_p), (rval_p))
 
#define VOL_CDEV_OPEN(dev, cred_p)                                      \
				drv_devopen(&dev,V_OFLAGS,VCHR,B_TRUE,cred_p) 
 
#define VOL_DEV_SIZE_FN(dev)                                            \
				drv_devsize

#define VOL_DEV_SIZE(dev)                                               \
				drv_devsize(dev)
#endif /* NSC */
 
#define VOL_DISK_DEV_OPEN(disk, region, cred_p)				\
		voluw_open_disk_device((disk), (region), (cred_p)) 

#define VOL_DISK_DEV_CLOSE(disk, region, cred_p)			\
		voluw_close_disk_device((disk), (region), (cred_p))
 
#if defined(TED_LOCKS) || defined(VOLMEM_DEBUG) && defined(UW_2_1)
#define VOL_INTERRUPT_CONTEXT           (servicing_interrupt())
#endif /* TED_LOCKS || VOLMEM_DEBUG && UW_2_1 */
 
#endif /* SOLARIS */

#define VOL_KDISK_IS_VALID(kdisk)					\
		((getmajor((kdisk)->kd_pub_dev) == volinfo.volbmajor)?0:1) 

#define VOL_GETMAJOR(d)		getmajor((d))
#define VOL_GETMINOR(d)		getminor((d))
#define VOL_MAKEDEVICE(x, y)	makedevice((x), (y))

/*
 * The following macros define the interface to timeouts.  A function
 * is expected to exist that registers a function to be called after
 * a period of time, but that can be canceled.  The timeout can be
 * canceled by passing the timeout value set by the timeout function.
 *
 * The function that is called when the timeout expires will be passed
 * the given arg pointer.
 *
 * VOL_TIMEOUT_SECONDS(secs) should be used to specify 'when'. The result
 * should be a translation of "secs" seconds into whatever the timout
 * takes as an argument. In this case, VOL_TIEMOUT() takes microseconds
 * which are translated into hz.
 */
#ifdef SOLARIS
typedef	int voltimeout_t;
#endif /* SOLARIS */

#ifdef UW_2_1
typedef	toid_t voltimeout_t;
#endif /* UW_2_1 */

#define	VOL_TIMEOUT_INIT(vt)		\
	(*(vt) = -1)

#ifdef SOLARIS
#define	VOL_TIMEOUT(vt, f, arg, when)	\
	(*(vt) = timeout((f), (arg), drv_usectohz((when))))
#endif /* SOLARIS */

#ifdef UW_2_1
#define VOL_TIMEOUT(vt, f, arg, when)   \
	(*(vt) = itimeout((f), (arg), drv_usectohz((when)),plhi))
#endif /* UW_2_1 */

#define VOL_UNTIMEOUT(vt)               \
        (untimeout(*(vt)), *(vt) = -1)

#define VOL_TIMEOUT_ISSET(vt)		\
	(*(vt) != -1)

#define VOL_TIMEOUT_SECONDS(secs)	((secs) * 1000000)

/*
 * The following macro delays the calling process for a short period
 * of time, letting other processes run on the processor. 
 */
#define VOL_DELAY()		(delay(1))

/*
 * Get the current clock value (in system-defined tick values).  The
 * clock value is stored in the clock_t value given as an argument.
 */
#define VOL_GET_CLOCK(_clock)	(drv_getparm(LBOLT, (ulong_t *)&(_clock)))
#define VOL_GET_PPID(_ppid)	(drv_getparm(PPID,  (ulong_t *)&(_ppid)))
#define VOL_GET_PROC(_proc)	(drv_getparm(UPROCP,(ulong_t *)&(_proc)))

/*
 * volioctl_info - structure for passing around ioctl information
 */
struct volioctl_info {
	volflag_t	vioc_flags;	/* flags pertaining to the ioctl */
	int		vioc_rval;	/* return value for the ioctl */
	struct cred	*vioc_cred;	/* credentials of the caller */
};

/* flags for volioctl_info.vioc_flags */
#define VOLIOC_FLAG_KERNEL	0x00000001	/* kernel-to-kernel ioctl */
#define VOLIOC_FLAG_RDOKAY	0x00000002	/* read operations are okay */
#define VOLIOC_FLAG_WROKAY	0x00000004	/* write operations are okay */

/* interface macros */
#define VOLIOCTL_RDOKAY(vioc)	((vioc)->vioc_flags & VOLIOC_FLAG_RDOKAY)
#define VOLIOCTL_WROKAY(vioc)	((vioc)->vioc_flags & VOLIOC_FLAG_WROKAY)
#define VOLIOCTL_OVERRIDE(vioc)	(!drv_priv((vioc)->vioc_cred))

/*
 * VOLIOCTL_KTOK_INFO - volioctl_info structure initialization for
 *			kernel-to-kernel VxVM ioctls
 */
#define VOLIOCTL_KTOK_INFO \
	{ \
		VOLIOC_FLAG_KERNEL | VOLIOC_FLAG_RDOKAY | VOLIOC_FLAG_WROKAY, \
		0, \
		NULL \
	}

/*
 * voldg_sys structure used for housing platform/system specific info.
 * currently in solaris there is none, so we just create a place holder.
 */
struct voldg_sys {
	int	dgsys_nothing;
};

/*
 * voldisk_sys structure used for housing platform/system specific info.
 * currently in solaris there is none, so we just create a place holder.
 */
struct voldisk_sys {
	void *pub_vp, *priv_vp;
};

/*
 * voldevice_sys structure used for housing platform/system specific info.
 * currently in solaris there is none, so we just create a place holder.
 */
struct voldevice_sys {
	int	vdevs_nothing;
};

/*
 * VOLSYS_SET_DEVICE - initialize the voldevice_sys field
 * VOLSYS_UNSET_DEVICE - uninitilize the voldevice_sys field
 *
 * Set up/break down any system-specific device information.
 * VOLSYS_SET_DEVICE() should return zero for success, nonzero on
 * failure. VOLSYS_UNSET_DEVICE() should return no status.
 *
 * For solaris, these are both no-ops.
 */
#define VOLSYS_SET_DEVICE(vdev, oldvdev)	0
#define VOLSYS_UNSET_DEVICE(vdev)

/*
 * VOLSYS_SET_DG - initialize any dg system-specific information
 * VOLSYS_UNSET_DG - clean up any dg system-specific information
 *
 * Similar to VOLSYS_SET/UNSET_DEVICE. Both should return
 * zero on success, nonzero on failure.
 *
 * For solaris, these are both no-ops.
 */
#define VOLSYS_SET_DG(dg)	0
#define VOLSYS_UNSET_DG(dg)	0

/*
 * voliomempage_t - type used for pagelists in iomem.c
 */
typedef struct page voliomempage_t;

/*
 * The following macros control the creation and deletion of daemon
 * processes.  These macros are VERY NON DDI/DKI compliant and so are
 * reduced to NULL if we are trying to be DDI compliant.
 * 
 * The p_exec pointer in the proc structure points to the held vnode for
 * the exec'd file.  Since we are becoming daemon kernel processes there
 * is no need to keep this vnode so we release it.  If we later exit,
 * then a check will be made before re-releasing the vnode so no problem
 * should occur with the exit.  If the system is brought down without
 * the process exiting, then the vnode will not be held and so the
 * shutdown will not be delayed.
 */

#define VOL_KTHREADS
#ifdef SOLARIS
/*
 * For Solaris, use kernel threads for I/O daemons.
 */
#define VOL_KTHREAD_CREATE(proc, arg) \
	(thread_create(NULL, 0, (void (*)())(proc), (arg), 0, &p0, \
		       TS_RUN, 60) == NULL? -1: 0)
#define VOL_KTHREAD_EXIT()	thread_exit()

#endif /* !SOLARIS */

#ifdef UW_2_1
#define VOL_KTHREAD_CREATE(proc, arg)                           \
                (spawn_sys_lwp(NULL, LWP_DETACHED,              \
                        (void (*)())(proc), (arg)))             \
 
#define VOL_KTHREAD_EXIT()                                      \
                (lwp_exit())                                    \
 
#endif /* !UW_2_1 */
 
#ifdef SOLARIS
/*
 * vxvm_stub_to_real - structure to map routines for use by other
 * drivers.
 */
struct vxvm_stub_to_real {
	int	(*volsopen)(voldevno_t *devp, int flag, int otyp, 
			    cred_t *credp);
	int	(*volsclose)(voldevno_t dev, int flag, int otyp, 
			     cred_t *credp);
	int	(*volsread)(voldevno_t dev, struct uio *uiop, cred_t *credp);
	int	(*volswrite)(voldevno_t dev, struct uio *uiop, cred_t *credp);
	int	(*volsioctl)(voldevno_t dev, int cmd, caddr_t arg, int mode,
			     cred_t *credp, int *rvalp);
	int	(*volschpoll)(voldevno_t, short, int, short *, 
			      struct pollhead **);
	int	*dbg_flag_p;
};
#endif /* SOLARIS */

/*
 * The following defines provide a portable method for OEMs to replace
 * the SVR4.2 cmn_err calls with their own variety of messaging and/or
 * logging schemes.
 */
#define VOL_NOTE_MSG(x,m)			cmn_err(CE_NOTE, m)
#define VOL_NOTE_MSG1(x,m,a)		cmn_err(CE_NOTE, m,a)
#define VOL_NOTE_MSG2(x,m,a,b)		cmn_err(CE_NOTE, m,a,b)
#define VOL_NOTE_MSG3(x,m,a,b,c)		cmn_err(CE_NOTE, m,a,b,c)
#define VOL_NOTE_MSG4(x,m,a,b,c,d)	cmn_err(CE_NOTE, m,a,b,c,d)
#define VOL_NOTE_MSG5(x,m,a,b,c,d,e)	cmn_err(CE_NOTE, m,a,b,c,d,e)
#define VOL_NOTE_MSG6(x,m,a,b,c,d,e,f)	cmn_err(CE_NOTE, m,a,b,c,d,e,f)
#define VOL_NOTE_MSG7(x,m,a,b,c,d,e,f,g) \
	cmn_err(CE_NOTE, m,a,b,c,d,e,f,g)
#define VOL_WARN_MSG(x,m)			cmn_err(CE_WARN, m)
#define VOL_WARN_MSG1(x,m,a)		cmn_err(CE_WARN, m,a)
#define VOL_WARN_MSG2(x,m,a,b)		cmn_err(CE_WARN, m,a,b)
#define VOL_WARN_MSG3(x,m,a,b,c)		cmn_err(CE_WARN, m,a,b,c)
#define VOL_WARN_MSG4(x,m,a,b,c,d)	cmn_err(CE_WARN, m,a,b,c,d)
#define VOL_WARN_MSG5(x,m,a,b,c,d,e)	cmn_err(CE_WARN, m,a,b,c,d,e)
#define VOL_WARN_MSG6(x,m,a,b,c,d,e,f)	cmn_err(CE_WARN, m,a,b,c,d,e,f)
#define VOL_WARN_MSG7(x,m,a,b,c,d,e,f,g) \
	cmn_err(CE_WARN, m,a,b,c,d,e,f,g)
#define VOL_PANIC_MSG(m)		cmn_err(CE_PANIC, m)
#define VOL_PANIC_MSG1(m,a)		cmn_err(CE_PANIC, m,a)
#define VOL_PANIC_MSG2(m,a,b)		cmn_err(CE_PANIC, m,a,b)
#define VOL_PANIC_MSG3(m,a,b,c)		cmn_err(CE_PANIC, m,a,b,c)
#define VOL_PANIC_MSG4(m,a,b,c,d)	cmn_err(CE_PANIC, m,a,b,c,d)
#define VOL_PANIC_MSG5(m,a,b,c,d,e)	cmn_err(CE_PANIC, m,a,b,c,d,e)
#define VOL_PANIC_MSG6(m,a,b,c,d,e,f)	cmn_err(CE_PANIC, m,a,b,c,d,e,f)
#define VOL_PANIC_MSG7(m,a,b,c,d,e,f,g)	cmn_err(CE_PANIC, m,a,b,c,d,e,f,g)

/*
 * The following macros are for debugging purposes and if compiled in using
 * the VXVM_DEBUG define, will cause some additional error messages to be
 * generated as appropriate under certain error conditions.  These messages
 * are NOT intended to replace the functionality of the TED_ASSERT
 * instrumentation but are provided as a simple mechanism for turning on
 * additional debugging information.
 *
 * Each message level represents the number of arguments supplied.
 */
#if defined(VXVM_DEBUG)

/*
 * The following two macros control the debugging level for any debugging 
 * messages.   In each C file that references one of the VOL_DBG_MSG macros,
 * the top of the file should contain the following two lines:
 *
 * 	#define VOL_DBG_VAR	VOL_DBG_NAME(filename)
 *	VOL_INIT_DBG(1)
 */

#define VOL_DBG_NAME(file)	vxvm_dbg_##file
#define VOL_INIT_DBG(lvl)	int	VOL_DBG_VAR = lvl;


#define VOL_DBG_MSG(lvl, fmt)						\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt));		\
		} while (ZERO)
#define VOL_DBG_MSG1(lvl, fmt, a)					\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a));		\
		} while (ZERO)
#define VOL_DBG_MSG2(lvl, fmt, a, b)					\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b));	\
		} while (ZERO)
#define VOL_DBG_MSG3(lvl, fmt, a, b, c)					\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b), (c));	\
		} while (ZERO)
#define VOL_DBG_MSG4(lvl, fmt, a, b, c, d)				\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b), (c),	\
					(d));				\
		} while (ZERO)
#define VOL_DBG_MSG5(lvl, fmt, a, b, c, d, e)				\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b), (c),	\
					(d), (e));			\
		} while (ZERO)
#define VOL_DBG_MSG6(lvl, fmt, a, b, c, d, e, f)			\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b), (c),	\
					(d), (e), (f));			\
		} while (ZERO)
#define VOL_DBG_MSG7(lvl, fmt, a, b, c, d, e, f, g)			\
		do {							\
			if (VOL_DBG_VAR >= (lvl) || vol_debug_level >= (lvl)) \
				cmn_err(CE_NOTE, (fmt), (a), (b), (c),	\
					(d), (e), (f), (g));		\
		} while (ZERO)

#else /* ! VXVM_DEBUG */

#define VOL_DBG_NAME(name)
#define VOL_INIT_DBG(lvl)

#define VOL_DBG_MSG(lvl, fmt)
#define VOL_DBG_MSG1(lvl, fmt, a)
#define VOL_DBG_MSG2(lvl, fmt, a, b)
#define VOL_DBG_MSG3(lvl, fmt, a, b, c)	
#define VOL_DBG_MSG4(lvl, fmt, a, b, c, d)
#define VOL_DBG_MSG5(lvl, fmt, a, b, c, d, e)
#define VOL_DBG_MSG6(lvl, fmt, a, b, c, d, e, f)
#define VOL_DBG_MSG7(lvl, fmt, a, b, c, d, e, f, g)

#endif /* VXVM_DEBUG */

/*
 * VOL_CALL_DEBUGGER() trap to a debugger, if possible
 */
#ifndef VXVM_DEBUG

#define VOL_CALL_DEBUGGER(arg, msg)

#else	/* VXVM_DEBUG */

#define VOL_CALL_DEBUGGER(arg, msg)	(vol_call_debugger((arg), (msg)))

#endif	/* VXVM_DEBUG */

#ifdef SOLARIS
/*
 * Some defines to avoid collisions with the Solaris Volume driver
 */
#define vol_cb_ops	vxio_cb_ops
#define vol_ops		vxio_ops
#define volclose	vxioclose
#define volinfo		vxioinfo
#define volioctl	vxioioctl
#define volopen		vxioopen
#define volprop_op	vxioprop_op
#define volread		vxioread
#define volstrategy	vxiostrategy
#define voltab		vxiotab
#define volwrite	vxiowrite
#define volsize		vxiosize

/*
 * A define for physiock, which doesn't exist on Solaris. VxVM
 * sources maps to physio
 */
#define volphysiock(strat, bp, dev, rw, devsize, uiop) \
	physio(strat, bp, dev, rw, minphys, uiop)

/*
 * Define a name for the driver that doesn't collide with the
 * Solaris Volume driver.
 */
#define VOL_DRIVER	"vxio"
#define	VOLS_DRIVER	"vxspec"

/*
 * Solaris does not define SD01_CMAJORS. All SCSI disks
 * fall under the same major number, so we can define
 * SD01_CMAJORS to be 1 here.
 */
#define SD01_CMAJORS	1

#else
 
#define volphysiock(strat, bp, dev, rw, devsize, uiop) \
        physiock((void (*)())strat, bp, dev, rw, devsize, uiop)
 
#endif /* SOLARIS */

#endif	/* _KERNEL */

#endif	/* _VXVM_VOLLOCAL_H */



